#!/bin/sh
VERSION=0.0.4
xgettext --package-name tivion --package-version $VERSION --default-domain tivion --output ../po/tivion.pot --from-code=utf-8 --copyright-holder="Ángel Guzmán Maeso <shakaran@gmail.com>" --msgid-bugs-address="shakaran@gmail.com" --language=Python ../src/tivion.py ../src/countries.py ../src/channels.py ../src/utils.py

# Spanish
mkdir -p ../src/lang/es/LC_MESSAGES/
cp ../po/es.po ../src/lang/es/LC_MESSAGES/tivion.po
msgfmt ../po/es.po -o ../src/lang/es/LC_MESSAGES/tivion.mo

# English (dont needed)
#mkdir -p ../src/lang/es/LC_MESSAGES/
#cp ../po/en.po ../src/lang/en/LC_MESSAGES/tivion.po
#msgfmt ../po/en.po -o ../src/lang/en/LC_MESSAGES/tivion.mo

# French
mkdir -p ../src/lang/fr/LC_MESSAGES/
cp ../po/fr.po ../src/lang/fr/LC_MESSAGES/tivion.po
msgfmt ../po/fr.po -o ../src/lang/fr/LC_MESSAGES/tivion.mo

# English - United Kingdom
mkdir -p ../src/lang/en_GB/LC_MESSAGES/
cp ../po/en_GB.po ../src/lang/en_GB/LC_MESSAGES/tivion.po
msgfmt ../po/en_GB.po -o ../src/lang/en_GB/LC_MESSAGES/tivion.mo       

# Catalan
mkdir -p ../src/lang/ca/LC_MESSAGES/
cp ../po/ca.po ../src/lang/ca/LC_MESSAGES/tivion.po
msgfmt ../po/ca.po -o ../src/lang/ca/LC_MESSAGES/tivion.mo

# Turkish
mkdir -p ../src/lang/tr/LC_MESSAGES/
cp ../po/tr.po ../src/lang/tr/LC_MESSAGES/tivion.po
msgfmt ../po/tr.po -o ../src/lang/tr/LC_MESSAGES/tivion.mo
 
# Italian
mkdir -p ../src/lang/it/LC_MESSAGES/
cp ../po/it.po ../src/lang/it/LC_MESSAGES/tivion.po
msgfmt ../po/it.po -o ../src/lang/it/LC_MESSAGES/tivion.mo

# Portuguese
mkdir -p ../src/lang/pt/LC_MESSAGES/
cp ../po/pt.po ../src/lang/pt/LC_MESSAGES/tivion.po
msgfmt ../po/pt.po -o ../src/lang/pt/LC_MESSAGES/tivion.mo

# Russian
mkdir -p ../src/lang/ru/LC_MESSAGES/
cp ../po/ru.po ../src/lang/ru/LC_MESSAGES/tivion.po
msgfmt ../po/ru.po -o ../src/lang/ru/LC_MESSAGES/tivion.mo

# Afrikaans
mkdir -p ../src/lang/af/LC_MESSAGES/
cp ../po/af.po ../src/lang/af/LC_MESSAGES/tivion.po
msgfmt ../po/af.po -o ../src/lang/af/LC_MESSAGES/tivion.mo

# Aragonese
mkdir -p ../src/lang/an/LC_MESSAGES/
cp ../po/an.po ../src/lang/an/LC_MESSAGES/tivion.po
msgfmt ../po/an.po -o ../src/lang/an/LC_MESSAGES/tivion.mo

# Arabic
mkdir -p ../src/lang/ar/LC_MESSAGES/
cp ../po/ar.po ../src/lang/ar/LC_MESSAGES/tivion.po
msgfmt ../po/ar.po -o ../src/lang/ar/LC_MESSAGES/tivion.mo

# Bosnian
mkdir -p ../src/lang/bs/LC_MESSAGES/
cp ../po/bs.po ../src/lang/bs/LC_MESSAGES/tivion.po
msgfmt ../po/bs.po -o ../src/lang/bs/LC_MESSAGES/tivion.mo

# Greek
mkdir -p ../src/lang/el/LC_MESSAGES/
cp ../po/el.po ../src/lang/el/LC_MESSAGES/tivion.po
msgfmt ../po/el.po -o ../src/lang/el/LC_MESSAGES/tivion.mo

# English (Australia)
mkdir -p ../src/lang/en_AU/LC_MESSAGES/
cp ../po/en_AU.po ../src/lang/en_AU/LC_MESSAGES/tivion.po
msgfmt ../po/en_AU.po -o ../src/lang/en_AU/LC_MESSAGES/tivion.mo

# Basque
mkdir -p ../src/lang/eu/LC_MESSAGES/
cp ../po/eu.po ../src/lang/eu/LC_MESSAGES/tivion.po
msgfmt ../po/eu.po -o ../src/lang/eu/LC_MESSAGES/tivion.mo

# Albanian
mkdir -p ../src/lang/sq/LC_MESSAGES/
cp ../po/sq.po ../src/lang/sq/LC_MESSAGES/tivion.po
msgfmt ../po/sq.po -o ../src/lang/sq/LC_MESSAGES/tivion.mo

# Klingon
mkdir -p ../src/lang/tlh/LC_MESSAGES/
cp ../po/tlh.po ../src/lang/tlh/LC_MESSAGES/tivion.po
msgfmt ../po/tlh.po -o ../src/lang/tlh/LC_MESSAGES/tivion.mo

# Chinese (Traditional)
mkdir -p ../src/lang/zh_TW/LC_MESSAGES/
cp ../po/zh_TW.po ../src/lang/zh_TW/LC_MESSAGES/tivion.po
msgfmt ../po/zh_TW.po -o ../src/lang/zh_TW/LC_MESSAGES/tivion.mo

# German
mkdir -p ../src/lang/de/LC_MESSAGES/
cp ../po/de.po ../src/lang/de/LC_MESSAGES/tivion.po
msgfmt ../po/de.po -o ../src/lang/de/LC_MESSAGES/tivion.mo

# Galician
mkdir -p ../src/lang/gl/LC_MESSAGES/
cp ../po/gl.po ../src/lang/gl/LC_MESSAGES/tivion.po
msgfmt ../po/gl.po -o ../src/lang/gl/LC_MESSAGES/tivion.mo

# Croatian
mkdir -p ../src/lang/hr/LC_MESSAGES/
cp ../po/hr.po ../src/lang/hr/LC_MESSAGES/tivion.po
msgfmt ../po/hr.po -o ../src/lang/hr/LC_MESSAGES/tivion.mo

# Indonesian
mkdir -p ../src/lang/id/LC_MESSAGES/
cp ../po/id.po ../src/lang/id/LC_MESSAGES/tivion.po
msgfmt ../po/id.po -o ../src/lang/id/LC_MESSAGES/tivion.mo

# Arabic
mkdir -p ../src/lang/ar/LC_MESSAGES/
cp ../po/ar.po ../src/lang/ar/LC_MESSAGES/tivion.po
msgfmt ../po/ar.po -o ../src/lang/ar/LC_MESSAGES/tivion.mo

# Asturian
mkdir -p ../src/lang/ast/LC_MESSAGES/
cp ../po/ast.po ../src/lang/ast/LC_MESSAGES/tivion.po
msgfmt ../po/ast.po -o ../src/lang/ast/LC_MESSAGES/tivion.mo

# Bulgarian
mkdir -p ../src/lang/bg/LC_MESSAGES/
cp ../po/bg.po ../src/lang/bg/LC_MESSAGES/tivion.po
msgfmt ../po/bg.po -o ../src/lang/bg/LC_MESSAGES/tivion.mo

# Occitan (post 1500)
mkdir -p ../src/lang/oc/LC_MESSAGES/
cp ../po/oc.po ../src/lang/oc/LC_MESSAGES/tivion.po
msgfmt ../po/oc.po -o ../src/lang/oc/LC_MESSAGES/tivion.mo

# Spanish (Argentina)
mkdir -p ../src/lang/es_AR/LC_MESSAGES/
cp ../po/es_AR.po ../src/lang/es_AR/LC_MESSAGES/tivion.po
msgfmt ../po/es_AR.po -o ../src/lang/es_AR/LC_MESSAGES/tivion.mo

# Portuguese (Brazil)
mkdir -p ../src/lang/pt_BR/LC_MESSAGES/
cp ../po/pt_BR.po ../src/lang/pt_BR/LC_MESSAGES/tivion.po
msgfmt ../po/pt_BR.po -o ../src/lang/pt_BR/LC_MESSAGES/tivion.mo