#!/bin/bash
# Required: sudo apt-get install gnupg-agent
# sudo gedit ~/.gnupg/gpg.conf and add use-agent

VERSION=0.0.4
# 0debian1
VERSIONUBU=0ubuntu6
VERSIONDEB=0ubuntu6
# +nmu1
NMU=
# .debian
NMUTAR=
KEY=1DEEE63E
DEB_BUILD_OPTIONS=hardening
# -O2
CFLAGS=-g 
CPPFLAGS=
LDFLAGS=-Wl,-Bsymbolic-functions
# -O2
FFLAGS=-g
# -O2
CXXFLAGS=-g


eval $(gpg-agent --daemon)

gpg-agent --daemon --enable-ssh-support \
           --write-env-file "${HOME}/.gpg-agent-info"


if [ -f "${HOME}/.gpg-agent-info" ]; then
       . "${HOME}/.gpg-agent-info"
       export GPG_AGENT_INFO
       export SSH_AUTH_SOCK
       export SSH_AGENT_PID
     fi

GPG_TTY=$(tty)
export GPG_TTY

echo "test" | gpg -ase -r 0x$KEY | gpg

function create_deb
{
    DIST=$1
    ARCH=$2
    
    NAMEVERSION=$VERSIONUBU
    #UNSTABLE='unstable'
    #if [ $DIST=$UNSTABLE ]; 
    #then
    #    NAMEVERSION=$VERSIONDEB
    #fi
    
    echo "* Creating $ARCH .deb package for $DIST..."
    dpkg-buildpackage -rfakeroot -k$KEY -a${ARCH} -m"Ángel Guzmán Maeso <shakaran@gmail.com>"

    lintian -i ../tivion_$VERSION-${NAMEVERSION}~${DIST}${NMU}_${ARCH}.deb 
    
    # -i exclude .bzr
    #debuild -S -sa -i -k1DEEE63E
    
    echo "* Moving $ARCH .deb $DIST files"
    cd ..
    mkdir -p ../../DEBS/ ../../DEBS/tivion-$VERSION-$DIST-deb/${ARCH}/
    echo "* Moving .deb"
    mv tivion_$VERSION-${NAMEVERSION}~${DIST}${NMU}_${ARCH}.deb ../../DEBS/tivion-$VERSION-$DIST-deb/${ARCH}/
    echo "* Moving .changes"
    mv tivion_$VERSION-${NAMEVERSION}~${DIST}${NMU}_${ARCH}.changes ../../DEBS/tivion-$VERSION-$DIST-deb/${ARCH}/
    echo "* Moving .tar.gz"
    mv tivion_$VERSION-$NAMEVERSION~${DIST}${NMU}.debian.tar.gz ../../DEBS/tivion-$VERSION-$DIST-deb/${ARCH}/
    echo "* Moving orig.tar.gz"
    mv tivion_$VERSION.orig.tar.gz ../../DEBS/tivion-$VERSION-$DIST-deb/${ARCH}/
    echo "* Moving .dsc"
    mv tivion_$VERSION-$NAMEVERSION~${DIST}${NMU}.dsc ../../DEBS/tivion-$VERSION-$DIST-deb/${ARCH}/
    cd tivion-$VERSION/
}

function make_deb
{
    DIST=$1
    
    NAMEVERSION=$VERSIONUBU
    #UNSTABLE='unstable'
    #if [$DIST=$UNSTABLE]; then
    #    NAMEVERSION=$VERSIONDEB
    #fi
    
    echo "* Cleaning $DIST folder..."
    rm -rf ../../tmp/${DIST}/tivion-$VERSION/
    echo "* Creating $DIST folder..."
    mkdir -p ../../tmp/${DIST}/tivion-$VERSION/tivion-$VERSION/
    cp -r ../../tivion-$VERSION/ ../../tmp/${DIST}/
    echo "* Coping debian $DIST folder..."
    cp -r ../../tivion-$VERSION/deb/$DIST/debian/ ../../tmp/${DIST}/tivion-$VERSION/
    echo "* Remove deb folder..."
    rm -rf ../../tmp/${DIST}/tivion-$VERSION/deb
    echo "* Remove script folder..."
    rm -rf ../../tmp/${DIST}/tivion-$VERSION/scripts
    echo "* Remove .bzr folder..."
    rm -rf ../../tmp/${DIST}/tivion-$VERSION/.bzr
    echo "* Remove .bzrignore file..."
    rm -rf ../../tmp/${DIST}/tivion-$VERSION/.bzrignore
    echo "* Remove backup.bzr folder..."
    rm -rf ../../tmp/${DIST}/tivion-$VERSION/backup.bzr
    echo "* Remove dist folder..."
    rm -rf ../../tmp/${DIST}/tivion-$VERSION/dist
    echo "* Remove svn folder..."
    rm -rf ../../tmp/${DIST}/tivion-$VERSION/src/svn
    echo "* Remove .po files..."
    rm -rf ../../tmp/${DIST}/tivion-$VERSION/po/*.po
    echo "* Remove src/bin folder..."
    rm -rf ../../tmp/${DIST}/tivion-$VERSION/src/bin
    echo "* Remove tivion-temp folder..."
    rm -rf ../../tmp/${DIST}/tivion-$VERSION/tivion-${VERSION}
    echo "* Removing *.pyc files..."
    rm -rf ../../tmp/${DIST}/tivion-$VERSION/src/*.pyc
    echo "* Removing Tivion.lnk file"
    rm -rf ../../tmp/${DIST}/tivion-$VERSION/src/Tivion.lnk
    echo "* Removing sp-sc-auth binary"
    rm -rf ../../tmp/${DIST}/tivion-$VERSION/src/lib/sp-sc-auth
    echo "* Removing tivion.nsi file"
    rm -rf ../../tmp/${DIST}/tivion-$VERSION/tivion.nsi
    
    echo "* Remove old tar.gz"
    rm -rf ../../tmp/${DIST}/tivion_$VERSION.orig.tar.gz
    cd ../../
    echo "* Create new orig.tar.gz"
    tar czf tmp/${DIST}/tivion_$VERSION.orig.tar.gz tmp/${DIST}/tivion-$VERSION
    cd tivion-${VERSION}/scripts
    
    cd ../../tmp/${DIST}/tivion-$VERSION/
    create_deb ${DIST} i386
    #create_deb ${DIST} amd64
    #mv ../tivion_$VERSION-${NAMEVERSION}~${DIST}${NMU}_source.changes ../../../DEBS/tivion-$VERSION-$DIST-deb/
    #debsign -k1DEEE63E ../../../DEBS/tivion-$VERSION-$DIST-deb/tivion_$VERSION-${NAMEVERSION}~${DIST}${NMU}_source.changes
    #cd ../../

    #rm -rf tmp/${DIST}/
    #cd ../tivion-$VERSION/scripts
    echo -e "* Packaging for ${DIST} finished."
}

#make_deb hardy
#make_deb intrepid
#make_deb jaunty
#make_deb karmic
#make_deb lucid
make_deb maverick
#make_deb unstable
#sh make_rpm.sh
#rm -rf ../../tmp/
