#!/bin/bash
# Required: sudo apt-get install gnupg-agent
# sudo gedit ~/.gnupg/gpg.conf and add use-agent

VERSION=0.0.4
# 0debian1
VERSIONDEB=4
# +nmu1
NMU=
# .debian
NMUTAR=
KEY=1DEEE63E
DEB_BUILD_OPTIONS=hardening
# -O2
CFLAGS=-g 
CPPFLAGS=
LDFLAGS=-Wl,-Bsymbolic-functions
# -O2
FFLAGS=-g
# -O2
CXXFLAGS=-g


eval $(gpg-agent --daemon)

gpg-agent --daemon --enable-ssh-support \
           --write-env-file "${HOME}/.gpg-agent-info"


if [ -f "${HOME}/.gpg-agent-info" ]; then
       . "${HOME}/.gpg-agent-info"
       export GPG_AGENT_INFO
       export SSH_AUTH_SOCK
       export SSH_AGENT_PID
     fi

GPG_TTY=$(tty)
export GPG_TTY

echo "test" | gpg -ase -r 0x$KEY | gpg

function create_deb
{
    ARCH=$1
    DIST=debian    
    NAMEVERSION=$VERSIONDEB
    #UNSTABLE='unstable'
    #if [ $DIST=$UNSTABLE ]; 
    #then
    #    NAMEVERSION=$VERSIONDEB
    #fi
    
    echo "* Creating $ARCH .deb package for $DIST..."
    dpkg-buildpackage -rfakeroot -k$KEY -a${ARCH} -m"Ángel Guzmán Maeso <shakaran@gmail.com>"

    lintian -i ../tivion_$VERSION-${NAMEVERSION}${NMU}_${ARCH}.deb 
    
    # -i exclude .bzr
    #debuild -S -sa -i -k1DEEE63E
    
    echo "* Moving $ARCH .deb $DIST files"
    cd ..
    mkdir -p ../../DEBS/ ../../DEBS/tivion-$VERSION-$DIST-deb/${ARCH}/
    echo "* Moving .deb"
    mv tivion_$VERSION-${NAMEVERSION}${NMU}_all.deb ../../DEBS/tivion-$VERSION-$DIST-deb/${ARCH}/
    echo "* Moving .changes"
    mv tivion_$VERSION-${NAMEVERSION}${NMU}_${ARCH}.changes ../../DEBS/tivion-$VERSION-$DIST-deb/${ARCH}/
    echo "* Moving .tar.gz"
    mv tivion_$VERSION-${NAMEVERSION}.debian.tar.gz ../../DEBS/tivion-$VERSION-$DIST-deb/${ARCH}/
    echo "* Moving orig.tar.gz"
    mv tivion_$VERSION.orig.tar.gz ../../DEBS/tivion-$VERSION-$DIST-deb/${ARCH}/
    echo "* Moving .dsc"
    mv tivion_$VERSION-${NAMEVERSION}${NMU}.dsc ../../DEBS/tivion-$VERSION-$DIST-deb/${ARCH}/
    cd tivion-$VERSION/
}

function make_deb
{
    NAMEVERSION=$VERSIONDEB
    
    echo "* Cleaning debian folder..."
    rm -rf ../../tmp/debian/tivion-$VERSION/
    echo "* Creating debian folder..."
    mkdir -p ../../tmp/debian/tivion-$VERSION/tivion-$VERSION/
    cp -r ../../tivion-$VERSION/ ../../tmp/debian/
    echo "* Coping debian folder..."
    cp -r ../../tivion-$VERSION/deb/unstable/debian/ ../../tmp/debian/tivion-$VERSION/
    echo "* Remove deb folder..."
    rm -rf ../../tmp/debian/tivion-$VERSION/deb
    echo "* Remove script folder..."
    rm -rf ../../tmp/debian/tivion-$VERSION/scripts
    echo "* Remove .bzr folder..."
    rm -rf ../../tmp/debian/tivion-$VERSION/.bzr
    echo "* Remove .bzrignore file..."
    rm -rf ../../tmp/debian/tivion-$VERSION/.bzrignore
    echo "* Remove backup.bzr folder..."
    rm -rf ../../tmp/debian/tivion-$VERSION/backup.bzr
    echo "* Remove dist folder..."
    rm -rf ../../tmp/debian/tivion-$VERSION/dist
    echo "* Remove svn folder..."
    rm -rf ../../tmp/debian/tivion-$VERSION/src/svn
    echo "* Remove .po files..."
    rm -rf ../../tmp/debian/tivion-$VERSION/po/*.po
    echo "* Remove src/bin folder..."
    rm -rf ../../tmp/debian/tivion-$VERSION/src/bin
    echo "* Remove tivion-temp folder..."
    rm -rf ../../tmp/debian/tivion-$VERSION/tivion-${VERSION}
    echo "* Removing *.pyc files..."
    rm -rf ../../tmp/debian/tivion-$VERSION/src/*.pyc
    echo "* Removing Tivion.lnk file"
    rm -rf ../../tmp/debian/tivion-$VERSION/src/Tivion.lnk
    echo "* Removing sp-sc-auth binary"
    rm -rf ../../tmp/debian/tivion-$VERSION/src/lib/sp-sc-auth
    # Avoid pedantic lintian warnings
    find ../../tmp/debian/tivion-$VERSION/src/ -type d -empty -delete
    echo "* Removing tivion.nsi file"
    rm -rf ../../tmp/debian/tivion-$VERSION/tivion.nsi
    echo "* Removing setup2.py file"
    rm -rf ../../tmp/debian/tivion-$VERSION/setup2.py
    echo "* Removing postinstall.py file"
    rm -rf ../../tmp/debian/tivion-$VERSION/src/postinstall.py
    echo "* Removing tivion_postinstall.py file"
    rm -rf ../../tmp/debian/tivion-$VERSION/src/tivion_postinstall.py
    echo "* Removing AUTHORS file"
    rm -rf ../../tmp/debian/tivion-$VERSION/AUTHORS
    
    echo "* Remove old tar.gz"
    rm -rf ../../tmp/debian/tivion_$VERSION.orig.tar.gz
    cd ../../
    echo "* Create new orig.tar.gz"
    tar czf tmp/debian/tivion_$VERSION.orig.tar.gz tmp/debian/tivion-$VERSION
    cd tivion-${VERSION}/scripts
    
    cd ../../tmp/debian/tivion-$VERSION/
    create_deb i386
    #create_deb ${DIST} amd64
    #mv ../tivion_$VERSION-${NAMEVERSION}~${DIST}${NMU}_source.changes ../../../DEBS/tivion-$VERSION-$DIST-deb/
    #debsign -k1DEEE63E ../../../DEBS/tivion-$VERSION-$DIST-deb/tivion_$VERSION-${NAMEVERSION}~${DIST}${NMU}_source.changes
    #cd ../../

    #rm -rf tmp/${DIST}/
    #cd ../tivion-$VERSION/scripts
    
    #echo -e "* Checking extra lintian warnings"
    #lintian --info --display-info --display-experimental --pedantic --show-overrides --checksums --color auto ../../../DEBS/tivion-$VERSION-$DIST-deb/${ARCH}/tivion*.changes
    
    echo -e "* Packaging for debian finished."
}

make_deb debian