# -*- coding: utf-8 -*-

# Py2exe
# http://downloads.sourceforge.net/project/py2exe/py2exe/0.6.9/py2exe-0.6.9.win32-py2.6.exe

# Required PyGTK:
# You can download PyGTK 2.16 (lastest for now) from:
# http://ftp.gnome.org/pub/GNOME/binaries/win32/pygtk/2.16/pygtk-2.16.0.win32-py2.6.exe

# PyObject:
# http://ftp.gnome.org/pub/GNOME/binaries/win32/pygobject/2.20/pygobject-2.20.0.win32-py2.6.exe

# Pycairo:
# http://ftp.gnome.org/pub/GNOME/binaries/win32/pycairo/1.8/pycairo-1.8.6.win32-py2.6.exe

# GTK+ Runtime
# http://downloads.sourceforge.net/project/gtk-win/GTK%2B%20Runtime%20Environment/GTK%2B%202.16/gtk2-runtime-2.16.6-2010-02-24-ash.exe

# GTK+ Themes
#http://downloads.sourceforge.net/project/gtk-win/GTK%2B%20Themes%20Package/2009-09-07/gtk2-themes-2009-09-07-ash.exe

# Command for create windows build:
# python setup2.py py2exe -O2 --dist-dir dist/windows/wbuild

# http://www.python.org/ftp/python/2.6.5/python-2.6.5.msi

import sys
reload(sys)
sys.setdefaultencoding('utf-8') # For spanish characters

import os
print os.getcwd()
sys.path.append(os.getcwd())

from distutils.core import setup

import os
import glob
import sys
import py2exe
import shutil

origIsSystemDLL = py2exe.build_exe.isSystemDLL

def isSystemDLL(pathname):
    dlls = ("msvcp71.dll", "dwmapi.dll", "jpeg62.dll","mfc71.dll")
    if os.path.basename(pathname).lower() in dlls:
            return 0
    return origIsSystemDLL(pathname)
    
py2exe.build_exe.isSystemDLL = isSystemDLL

sep = os.sep
tivion_install_path = ''
src_dir = 'src' + os.sep
lang_dir = '\\usr\\share\\locale'
img_dir = 'data\\img\\'

class Target:
    def __init__(self,**kw):
        self.__dict__.update(kw)
        self.author = 'Ángel Guzmán Maeso'
        self.author_email = 'shakaran@gmail.com'
        self.description = 'A simple player to online TV streaming'
        self.long_description = 'A simple player and recorder for streaming online television and radio \nchannels composed of multicultural and international level.'
        self.maintainer = 'Ángel Guzmán Maeso'
        self.maintainer_email = 'shakaran@gmail.com'
        self.url = 'http://www.shakaran.net'
        self.download_url = 'http://www.shakaran.net/blog/tivion'
        self.classifiers=[
         'Development Status :: 4 - Beta',
         'Environment :: GUI',
         'Intended Audience :: End Users/Desktop',
         'License :: OSI Approved :: GNU/GPL v.3.0',
         'Operating System :: Microsoft :: Windows',
         'Operating System :: POSIX',
         'Programming Language :: Python',
         ]
        self.platforms = ['Posix','Windows XP', 'Windows 2000','Windows Vista']
        self.version        = "0.0.4"
        self.compay_name    = "Tivion Project"
        self.copyright      = "(c) 2009-2010, Ángel Guzmán Maeso"
        self.name           = "Tivion"
        self.icon_resources =  [(0, "src/data/img/tivion.ico")]

target = Target(script = src_dir + 'tivion.py')

data_files_installed = [
      
            ## Installing the executable
            (tivion_install_path, [src_dir + 'tivion.py']),
            
            
            ## Installing the channels, constants, utils and countries module
            (tivion_install_path, [src_dir + 'channels.py']),
            (tivion_install_path, [src_dir + 'constants.py']),
            (tivion_install_path, [src_dir + 'countries.py']),
            (tivion_install_path, [src_dir + 'utils.py']),
            
             ## Installing the data files (logo and images)
            (tivion_install_path + img_dir, [src_dir + img_dir + 'tivion.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'tivion-icon.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'tivion-icon.svg']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'tivion-launcher.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'tivion-frame.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'all.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'media-playback-start.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'pause_bg.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'play_bg.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'radio.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'sopcast.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'tv.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'camera-photo.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'audio-volume-muted.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'audio-volume-high.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'audio-volume-low.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'audio-volume-medium.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'lpi-help.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'lpi-translate.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'lpi-bug.png']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'tivion.bmp']),
            (tivion_install_path + img_dir, [src_dir + img_dir + 'tivion.xcf']),
            
            ## Installing the locale files
            
            # Catala
            ('lang' + sep + 'ca' + sep + 'LC_MESSAGES' + sep, 
            [src_dir + 'lang' + sep + 'ca' + sep + 'LC_MESSAGES' + sep + 'tivion.po']),
            ('lang' + sep + 'ca' + sep + 'LC_MESSAGES' + sep, 
            [src_dir + 'lang' + sep + 'ca' + sep + 'LC_MESSAGES' + sep + 'tivion.mo'])
            
            ]

data_files_installed.append((tivion_install_path, [src_dir + 'bin//mplayer.exe']))

setup(
    windows = [target],
    data_files = data_files_installed,
    options = {
                'py2exe': {
                            'includes': 'cairo, pango, pangocairo, gtk, gobject, glib, atk', #
                            'optimize': 2,
                            #'excludes':'doctest,pdb,unittest,difflib,inspect',
                            'compressed': 1,
                            'ascii': 1,
                            'skip_archive':0,
                            'unbuffered':True,
                            'bundle_files': 1
                           }
               },
)
