#!/usr/bin/env python
# -*- coding: utf-8 -*-

## Tivion
## Copyright (C) 2009 Ángel Guzmán Maeso
## http://shakaran.net
##
## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.

import time
import os
import platform

# Constants
VERSION_NUMBER     = '0.0.5'
VERSION_NAME       = 'Tivion'
VERSION            = VERSION_NAME + ' ' + VERSION_NUMBER
if platform.system() == 'Windows':
    #LOCALE_DIR     = os.environ['PROGRAMFILES'] + '/' + VERSION_NAME + '/locale'
    LOCALE_DIR     = None
else:
    LOCALE_DIR     = '/usr/share/locale'
APP_PATH           = '/usr/share/tivion/'
DEV_APP_PATH       = 'src/'
LIB_PATH           = '/usr/share/tivion/lib/'
DEV_LIB_PATH       = 'lib/'
if platform.system() == 'Windows':
    IMG_PATH       = os.environ['PROGRAMFILES'] + os.sep + VERSION_NAME + '\\data\\img\\'
    DEV_IMG_PATH   = 'data' + os.sep + 'img' + os.sep
else:
    IMG_PATH        = '/usr/share/tivion/data/img/'
    DEV_IMG_PATH       = 'data/img/'
if platform.system() == 'Windows':
    TMP = os.environ['TMP'] + '\\'
else:
    TMP = '/tmp/'
FIFO               = TMP + 'tivion-fifo-%d' % time.time()
STDOUT             = TMP + 'tivion-out-%d' % time.time()
STDERR             = TMP + 'tivion-err-%d' % time.time()
DEBUG              = False
DEFAULT_VO         = 'gl2' # OpenGL 2
DEFAULT_CACHE_SIZE = 390
CONFIG_FILE        = 'config.cfg'
PLAY_CHANNEL_ID    = None
PLAY_CHANNEL_URL   = None

# Debian, Ubuntu [FIXME] Add more plattaforms
license_filename   = "/usr/share/common-licenses/GPL-3"

# Tree model
(
    COLUMN_ID,
    COLUMN_COUNTRY,
    COLUMN_TYPE,
    COLUMN_NAME,
    COLUMN_URL,
    COLUMN_FORMAT_TYPE
) = range(6)

# Channel Type
(
    TV,
    RADIO,
    SOPCAST,
) = range(3)

# Format Type
(
    PLS,
    ASX,
    RM,
    UNKNOWN,
    M3U,
    MP3,
) = range(6)

lastProcess = None
