#!/usr/bin/env python
# -*- coding: utf-8 -*-

## Tivion
## Copyright (C) 2009-2010 Ángel Guzmán Maeso
## http://shakaran.es
##
## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.

import constants as cons
import locale
import gettext
locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain('tivion', cons.LOCALE_DIR)
gettext.textdomain('tivion')
_ = gettext.gettext
dom = gettext.dgettext

"""
print dom('iso_3166', 'Spain'), dom("iso_639_3", "Spanish")
print dom('iso_3166', 'Germany'), dom("iso_639_3", "German")
print dom('iso_3166', 'France'), dom("iso_639_3", "French")
print dom('iso_3166_alpha_2', 'France'), dom("iso_639_3", "French")
"""

# Tranlations for countries
# Naming with ISO 3166-1 alpha-2
# http://www.iso.org/iso/country_codes/iso_3166_code_lists/english_country_names_and_code_elements.htm
# http://en.wikipedia.org/wiki/ISO_3166-1
es_ES = dom('iso_3166', 'Spain')
en_GB = dom('iso_3166', 'United Kingdom')
ar_AR = dom('iso_3166', 'Argentina')
ru_RU = dom('iso_3166', 'Russia')
th_TH = dom('iso_3166', 'Thailand')
en_US = dom('iso_3166', 'USA')
fr_FR = dom('iso_3166', 'France')
de_DE = dom('iso_3166', 'Germany')
it_IT = dom('iso_3166', 'Italy')
cl_CL = dom('iso_3166', 'Chile')
pl_PL = dom('iso_3166', 'Poland')
mx_MX = dom('iso_3166', 'Mexico')
so_af = dom('iso_3166', 'South Africa')
cn_CN = dom('iso_3166', 'China')
tr_TR = dom('iso_3166', 'Turkey')
do_DO = dom('iso_3166', 'Dominican Republic')
be_BE = dom('iso_3166', 'Belgium')
ca_CA = dom('iso_3166', 'Canada')
nl_NL = dom('iso_3166', 'Netherlands')
at_AT = dom('iso_3166', 'Austria')
ch_CH = dom('iso_3166', 'Switzerland')
se_SE = dom('iso_3166', 'Sweden')
gr_GR = dom('iso_3166', 'Greece')
ro_RO = dom('iso_3166', 'Romania')
al_AL = dom('iso_3166', 'Albania')
hu_HU = dom('iso_3166', 'Hungary')
si_SI = dom('iso_3166', 'Slovenia')
pt_PT = dom('iso_3166', 'Portugal')
eg_EG = dom('iso_3166', 'Egypt')
no_NO = dom('iso_3166', 'Norway')
cu_CU = dom('iso_3166', 'Cuba')
cg_CG = dom('iso_3166', 'Congo')
ba_BA = dom('iso_3166', 'Bosnia and Herzegovina')
li_LY = dom('iso_3166', 'Libya')
za_ZA = dom('iso_3166', 'South Africa')
in_IN = dom('iso_3166', 'India')
ir_IR = dom('iso_3166', 'Iran')
kr_KR = dom('iso_3166', 'South Korea')
jp_JP = dom('iso_3166', 'Japan')
ag_AG = dom('iso_3166', 'Antigua and Barbuda')
ad_AD = dom('iso_3166', 'Andorra')
bz_BZ = dom('iso_3166', 'Belize')
sv_SV = dom('iso_3166', 'El salvador')
bo_BO = dom('iso_3166', 'Bolivia')
co_CO = dom('iso_3166', 'Colombia')
mt_MT = dom('iso_3166', 'Malta')
kw_KW = dom('iso_3166', 'Kuwait')
qa_QA = dom('iso_3166', 'Qatar')
lb_LB = dom('iso_3166', 'Lebanon')
jo_JO = dom('iso_3166', 'Jordan')
il_IL = dom('iso_3166', 'Israel')
lu_LU = dom('iso_3166', 'Luxemburgo')
pk_PK = dom('iso_3166', 'Pakistan')
iq_IQ = dom('iso_3166', 'Iraq')
am_AM = dom('iso_3166', 'Armenia')
kz_KZ = dom('iso_3166', 'Kazakhstan')
cz_CZ = dom('iso_3166', 'Czech Republic')
bg_BG = dom('iso_3166', 'Bulgaria')
az_AZ = dom('iso_3166', 'Azerbaijan')
lv_LV = dom('iso_3166', 'Latvia')
ee_EE = dom('iso_3166', 'Estonia')
au_AU = dom('iso_3166', 'Australia')
vn_VN = dom('iso_3166', 'Vietnam')
ve_VE = dom('iso_3166', 'Venezuela')
br_BR = dom('iso_3166', 'Brazil')
dk_DK = dom('iso_3166', 'Denmark')
hr_HR = dom('iso_3166', 'Croatia')
aq_AQ = dom('iso_3166', 'Antarctica')
as_AS = dom('iso_3166', 'American Samoa')
lt_LT = dom('iso_3166', 'Lithuania')
ae_DU = dom('iso_3166', 'United Arab Emirates')