# -*- coding: utf-8 -*-

import sys
import os
import os.path
import distutils.sysconfig
import distutils.file_util
import distutils.errors

def create_shortcuts():
    
    progs_folder = get_special_folder_path('CSIDL_COMMON_PROGRAMS')
    tivion_dir = os.path.join(progs_folder, 'Tivion')
    print 'Installed on:\n' + tivion_dir + '\n'
    
    if not os.path.isdir(tivion_dir):
        print 'Created dir:\n' + tivion_dir + '\n'
        os.mkdir(tivion_dir)

    # Images
    

    tivion_link = os.path.join(tivion_dir, 'Tivion.lnk')
        
    if os.path.exists(tivion_link) and os.path.isfile(tivion_link):   
        print 'Cleaning old shorcuts:\n' + tivion_link + '\n'
        os.remove(tivion_link)
        
    arguments = 'tivion.py'
    
    #create_shortcut(tivion_dir + 'tivion.py', 'A simple streaming player', tivion_link, arguments, tivion_dir)
    print 'Creating shorcuts...' #
    create_shortcut(os.path.join(sys.prefix, 'pythonw.exe'), 
                                 'A simple streaming player 4', 
                                 tivion_link, 
                                 arguments, 
                                 tivion_dir)
    file_created(tivion_link)

if len(sys.argv) == 2:
    if sys.argv[1] == '-install':
        create_shortcuts()
        
        print 'Tivion is now installed on your machine.\nLocal configuration files were successfully updated.'
    
    elif sys.argv[1] == "-remove":
        print 'Tivion is now uninstalled on your machine.\nLocal configuration files were successfully updated.'
        #os.remove()
    else:
        print 'This script is meant to be run by the Windows \ninstaller, not directly from the command line.'
else:
    print 'This script is meant to be run by the Windows \ninstaller, not directly from the command line.'
