#!/usr/bin/env python
# -*- coding: utf-8 -*-

## Tivion
## Copyright (C) 2009-2010 Ángel Guzmán Maeso
## http://shakaran.net
##
## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Tivion = TiViOn = TV Online
import constants as cons
print cons.VERSION

# [TODO]
# -Choose at start if there are some channel for reproduce directly

import sys
import os

import platform
import random

import locale
import gettext

# Put the initial locale

if platform.system() == 'Windows':
    gettext.install('translate','locale')
    cur_locale = locale.setlocale(locale.LC_ALL, '')
    if cons.DEBUG:
        print locale.getdefaultlocale()
else:
    cur_locale = locale.setlocale(locale.LC_ALL, None)
    if cons.LOCALE_DIR == None:
        cons.LOCALE_DIR = gettext._default_localedir
    gettext.bindtextdomain('tivion', cons.LOCALE_DIR)
    gettext.textdomain('tivion')



_ = gettext.gettext

try:
    import gtk
except:
    print _('You need install GTK to run Tivion.')
    sys.exit(1)

gtk_v = gtk.gtk_version

if platform.system() != 'Windows':
    if gtk_v < (2, 12):
        print _('You need GTK 2.12 or higher to run Tivion.')
        sys.exit(1)

try:
    import pygtk
except:
    print _('You need install PyGTK to run Tivion.')
    sys.exit(1)

pygtk.require('2.0')
pygtk_v = gtk.pygtk_version

if platform.system() != 'Windows':
    if pygtk_v < (2, 12):
        print _('You need PyGTK 2.12 or higher to run Tivion.')
        sys.exit(1)

if platform.system() != 'Windows':
    gtk.settings_get_default().set_long_property('gtk-button-images', True, 'main')

def register_iconsets(icon_info):
    try:
        iconfactory = gtk.IconFactory()
        #stock_ids = gtk.stock_list_ids()
        for (stock_id, image) in icon_info:
            try:
                pixbuf = gtk.gdk.pixbuf_new_from_file(os.path.join(cons.IMG_PATH, image))
            except:
                pixbuf = gtk.gdk.pixbuf_new_from_file(os.path.join(cons.DEV_IMG_PATH, image))

            iconset = gtk.IconSet(pixbuf)
            iconfactory.add(stock_id, iconset)
        iconfactory.add_default()
    except Exception, e:
        print e

register_iconsets([
        ('media-playback-start', 'media-playback-start.png'),
        ('camera-photo', 'camera-photo.png'),
        ('audio-volume-high', 'audio-volume-high.png'),
        ('audio-volume-low', 'audio-volume-low.png')
        ])

import subprocess as sp
from subprocess import Popen
import time
import urllib
import re

import gobject
gobject.threads_init()

import utils as u
# Read the locale from config file
cfg = u.Config()
cfg_lang = cfg.cfg.get('OPTIONS', 'Lang'.lower())
#print 'cfg_lang:', cfg_lang

if platform.system() != 'Windows':
    try:
        import gnome
    except:
        print _('You need install python-gnome or gnome-python (ArchLinux) to run Tivion.')
        sys.exit(1)

from threading import Thread

class showCmd(Thread):

    def __init__(self, proc, pb, ptimeout, tiv):
        Thread.__init__(self)

        self.proc = open(cons.STDOUT, 'r')
        self.quit = False
        self.progressbar = pb
        self.isStop = False
        self.init_channel = False
        self.progress_timeout = ptimeout
        self.app = tiv

    def read_file(self):
        lineList = self.proc.readlines()
        #for line2 in open(cons.STDOUT,"r"):
        #    print 'L', line2,
        try:
            if cons.DEBUG: # This needs to be improved.
                # We only reads the last line
                # For timeouts, we need read all lines and parse each one.
                print 'LINELIST:', lineList[-1]
            line = lineList[-1]
            line = line.split()

            if cons.DEBUG:
                print line[13]

            if self.app.isPlaying == True:
                if not self.progressbar.get_property('visible'):
                    self.progressbar.set_property('visible', True)
                #print len(line)
                if cons.DEBUG:
                    print '[0=' + line[0] + ']', line[1], line[2], line[3],
                    print line[4], '[5=' + line[5] + ']', line[6], line[7]
                    #, line[8], line[9], line[10], line[11], line[12], line[13]
                try:
                    if line[0] == 'Cache':  # Cache fill: 2.05% (8192 bytes)
                        aux = line[2]
                        l = aux.split('%')
                        l = int(float(l[0])) / 100.0
                        self.progressbar.set_fraction(l)
                        self.progressbar.set_text(_('Cache Fill %s' % aux))
                    else:
                        aux = line[13]
                        if aux == '-0.0':
                            aux = line[7]

                        l = aux.split('%')
                        l = int(l[0]) / 100.0
                        self.progressbar.set_fraction(l)
                        self.progressbar.set_text(aux)
                except ValueError:
                    aux = line[12]
                    l = aux.split('%')
                    try:
                        l = int(float(l[0])) / 100.0
                    except:
                        l = 0
                    self.progressbar.set_fraction(l)
                    self.progressbar.set_text(aux)

                self.init_channel = True
                self.progressbar.show()
        except IndexError:
            self.init_channel = False
            if self.app.pt_enter == False:
                # Add callback for progressbar
                gobject.timeout_add(100, self.progress_timeout, self)
            pass

    def run(self):
        try:
            while not self.quit:
                if cons.DEBUG:
                    print _('Show command running...')
                gobject.idle_add(self.read_file)
                time.sleep(0.5)
        except e:
            print _('Error: Error with show command thread:'), e


class sopcastThread(Thread):

    def __init__(self, sp_command):
        Thread.__init__(self)
        self.sp_proc = None
        self.quit = False
        self.sp_command = sp_command

    def run(self):
        try:
            if cons.DEBUG:
                dnull = None
            else:
                dnull = open('/dev/null', 'w')
            self.sp_proc = Popen(self.sp_command.split(),
                                 stdout=dnull,
                                 stderr=dnull)
            while not self.quit:
                if cons.DEBUG:
                    print self.sp_command
                time.sleep(1.0)

            if self.quit and self.sp_proc:
                u.pterminate(self.sp_proc)
        except ValueError:
            print _('Error: Error with sopcast player thread:'), e

### FIX for ALSA:
# [AO OSS] audio_setup: Can't open audio device /dev/dsp: Device or resource busy
# -ao alsa
# Specify default audio driver (see 'mplayer -ao help' for a list).
# ao=alsa,oss,sdl,esd,arts

# [TODO]
# mplayer -input cmdlist
class Tivion():
    isPlaying = False
    isPaused  = False
    isStop    = False
    cleanArea = True
    currentNameChannel = None
    volume = 50
    keepAbove = False
    winfullscreen = False
    last_msg_pushed = None
    ss_dir = u.get_home() + '/.tivion/'+ _('captures')
    sp_port = 8908
    sp_tcp_port = 3908
    mplayer_bin = u.get_mplayer_bin()
    random_channel = None

    def __init__(self):
        self.__do_main_window()

    def __do_main_window(self):
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)

        self.window.set_title(cons.VERSION)
        self.window.set_default_size(450, 320)
        self.window.set_position(gtk.WIN_POS_CENTER)
        self.window.set_gravity(gtk.gdk.GRAVITY_CENTER)
        self.window.set_border_width(0)
        self.window.set_app_paintable(True)

        try:
            gtk.window_set_default_icon_from_file(os.path.join(cons.IMG_PATH, 'tivion-icon.png'))
        except: # Give a try with development path
            gtk.window_set_default_icon_from_file(os.path.join(cons.DEV_IMG_PATH, 'tivion-icon.png'))

        self.window.connect("destroy", self.on_destroy) # Needs testing: gtk.main_quit
        self.window.connect("key-press-event", self.on_key_press_event)
        self.window.connect("delete_event", self.on_delete_event)
        self.window.connect("destroy_event", self.on_destroy_event)

        self.create_pipes()
        self.__do_main_vbox()
        self.window.add(self.main_vbox)
        self.window.show_all()
        self.progressbar.hide()

        # [TODO] Improve this feature for get the name, format, channel type or other attributes
        if cons.PLAY_CHANNEL_ID != None:
            played_channel_data = self.channels_set[cons.PLAY_CHANNEL_ID]
            [id, country, channel_type, name, url, format_type] = played_channel_data
            print _('Played channel choose: %s - %s' %(id, name))
            self.execute_channel(id, country, name, url, format_type, channel_type)
        elif cons.PLAY_CHANNEL_URL != None:
            print _('Played channel choose: %s - %s' %(id, name))
            self.execute_channel(-1, 'Unknown', 'User channel choose', cons.PLAY_CHANNEL_URL, '', '')
        else:
            self.random_channel = self.get_random_channel_state()
            if self.random_channel == 1:
                index_random = random.randint(1, len(self.channels_set))
                self.random_channel = 0
                if cons.DEBUG:
                    print _('Random index channel choose: %s' %index_random)
                random_channel_data = self.channels_set[index_random]
                [id, country, channel_type, name, url, format_type] = random_channel_data
                print _('Random channel choose: %s - %s' %(id, name))
                self.execute_channel(id, country, name, url, format_type, channel_type)

        # Channel updater on init

        #countries_url = urllib.urlopen('http://bazaar.launchpad.net/%7Eshakaran/tivion/tivion/download/head%3A/countries.py-20091203012607-k1uhci1qrn7gcie7-1/countries.py').read()
        #countries_list = re.findall("(.+?) \= \_\(\'(.+?)\'\)", countries_url)
        #print countries_list
        #for country_key, name in countries_list:
        #    print country_key, name

        #[TODO] Lanzar un thread justo aqui
        self.channel_updater = u.ChannelUpdater();
        self.channel_updater.start()
        self.channel_updater.join(0.5)

    def __do_main_vbox(self):
        # load accelerator keys
        self.accel_map_filename = u.get_home() + '/.tivion/.accelerators'

        self.main_vbox = gtk.VBox(0, True)
        self.main_vbox.set_border_width(0)

        self.menubar = self.__create_menubar()
        self.main_vbox.pack_start(self.menubar, False, False, 0)
        self.__do_main_hbox()
        self.main_vbox.pack_start(self.main_hbox, True, True, 0)

        self.statusbar = self.__create_statusbar()
        self.__do_progressbar()
        self.__do_sub_hbox()
        self.main_vbox.pack_end(self.sub_hbox, False, False, 0)

    def __do_sub_hbox(self):
        self.sub_hbox = gtk.HBox(0, True)
        self.sub_hbox.set_border_width(0)
        self.sub_hbox.pack_start(self.progressbar, False, False, 0)
        self.sub_hbox.pack_start(self.statusbar, True, True, 0)

    def __do_progressbar(self):
        self.progressbar = gtk.ProgressBar(adjustment=None)
        self.progressbar.set_size_request(120, 20)
        self.progressbar.set_orientation(gtk.PROGRESS_LEFT_TO_RIGHT)
        self.progressbar.set_pulse_step(0.01)
        self.progressbar.set_fraction(0.0)
        self.progressbar.set_text('')
        self.progressbar.set_property('visible', False)
        self.progressbar.hide()

    def __do_main_hbox(self):
        self.__do_drawing_area()
        self.main_hbox = gtk.HBox(0,True)
        self.main_hbox.set_border_width(0)
        self.main_hbox.pack_start(self.videoArea, True, True, 0)
        self.main_hbox.connect('expose-event', self.draw_pixbuf)

        self.__do_scroll_window()
        self.__do_right_vbox_panel()

        self.main_hbox.pack_start(self.vbox_panel, expand=False, fill=True, padding=0)

    def __do_drawing_area(self):
        self.videoArea = gtk.DrawingArea();
        self.videoArea.set_events(gtk.gdk.EXPOSURE_MASK
                                | gtk.gdk.LEAVE_NOTIFY_MASK
                                | gtk.gdk.BUTTON_PRESS_MASK
                                | gtk.gdk.POINTER_MOTION_MASK
                                | gtk.gdk.POINTER_MOTION_HINT_MASK)
        # Event signals
        ###self.videoArea.connect("configure_event", self.configure_event)
        #self.videoArea.connect("motion_notify_event", self.motion_notify_event)
        self.videoArea.connect("button_press_event", self.button_press_event)

        self.videoArea.set_size_request(320, 280)
        self.videoArea.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#3c3c3c"))
        try:
            self.img_frame = gtk.gdk.pixbuf_new_from_file(os.path.join(cons.IMG_PATH, 'tivion-frame.png')) # at_size dont work!
            self.img_pause = gtk.gdk.pixbuf_new_from_file(os.path.join(cons.IMG_PATH, 'pause_bg.png')) # at_size dont work!
        except: # Give a try with development path
            self.img_frame = gtk.gdk.pixbuf_new_from_file(os.path.join(cons.DEV_IMG_PATH, 'tivion-frame.png')) # at_size dont work!
            self.img_pause = gtk.gdk.pixbuf_new_from_file(os.path.join(cons.DEV_IMG_PATH, 'pause_bg.png')) # at_size dont work!

    def motion_notify_event(self, widget, event):
        if event.is_hint:
            x, y, state = event.window.get_pointer()
        else:
            x = event.x
            y = event.y
            state = event.state

        #print x, y, state

        #print 'motion notify'
        #if state & gtk.gdk.BUTTON1_MASK and pixmap != None:
        #    draw_brush(widget, x, y)

        return True

    def button_press_event(self, widget, event):
        x, y, w, h = widget.get_allocation()
        if event.x >= x and event.x <= x + w and event.y >= y and event.y <= h:
            if event.button == 1 and event.type == gtk.gdk.BUTTON_PRESS:
                self.on_activate_pause(None)
            elif event.button == 3 and event.type == gtk.gdk.BUTTON_PRESS:
                print 'button clack', event.x, event.y
        return True

    def draw_pixbuf(self, widget, event):
        if not self.isPlaying or self.isPaused or self.isStop:
            w, h = self.videoArea.window.get_size()

            # gtk.gdk.INTERP_HYPER Slow & best quality. Others: gtk.gdk.INTERP_TILES, gtk.gdk.INTERP_BILINEAR
            if self.isPaused:
                pixb = self.img_pause #.scale_simple(w, h, gtk.gdk.INTERP_NEAREST)
                dx = w/2 - pixb.get_width()/2
                dy = h/2 - pixb.get_height()/2
            else:
                pixb = self.img_frame.scale_simple(w, h, gtk.gdk.INTERP_HYPER)
                dx = 0
                dy = 0

            self.videoArea.window.draw_pixbuf(
                            gc = self.videoArea.style.bg_gc[gtk.STATE_NORMAL],
                            pixbuf = pixb,
                            src_x = 0, src_y = 0,
                            dest_x = dx, dest_y = dy,
                            width = -1, height = -1
                        )
            if self.isStop and not self.cleanArea:
                self.videoArea.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#3c3c3c"))
                self.cleanArea = True
                self.draw_pixbuf(None, None)

            return False

    def __do_channels(self):
        self.__Channels()
        import channels
        self.channels_set = channels.CHANNEL

        self.countries_names = {}
        for c in self.channels_set:
            if self.countries_names.get(unicode(c[1])) == None:
                self.countries_names[unicode(c[1])] = 1

        self.__insert_channels()

    def __do_scroll_window(self):
        self.sw = gtk.ScrolledWindow()
        self.sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.sw.set_size_request(200,-1)
        self.sw.set_shadow_type(gtk.SHADOW_IN)
        self.__do_channels()
        self.sw.add(self.channels)

    def __do_right_vbox_panel(self):
        self.vbox_panel = gtk.VBox(0, True)
        self.vbox_panel.set_border_width(0)
        self.__do_hbox_panel_up()
        self.vbox_panel.pack_start(self.hbox_panel_up , False, True, 0)
        #self.vbox_panel.pack_start(u.entrySearch(self), False, True, 0)
        self.vbox_panel.pack_start(self.sw, True, True, 0)
        self.vbox_panel.pack_start(self.__create_hbox_buttons(), False, False, 0)

    def __do_hbox_panel_up(self):
        self.hbox_panel_up = gtk.HBox(0, True)
        self.hbox_panel_up.set_border_width(0)
        #self.hbox_panel_up.pack_start(self.__combobox_channels_type() , True, True, 0)
        self.hbox_panel_up.pack_start(u.entrySearch(self) , True, True, 0)
        button = u.ButtonUnLabeled(stock = gtk.STOCK_CLOSE)
        button.set_relief(gtk.RELIEF_NONE)
        button.set_tooltip_text(_('Close channel list'))
        button.connect('clicked', self.toggle_channel_list)
        self.hbox_panel_up.pack_start(button, False, True, 0)

    def create_pipes(self):
        if os.path.exists(cons.FIFO):
            os.unlink(cons.FIFO)

        if os.path.exists(cons.STDOUT):
            os.unlink(cons.STDOUT)
        if platform.system() == 'Windows':
            file(cons.STDOUT, 'w')

        if os.path.exists(cons.STDERR):
            os.unlink(cons.STDERR)

        #file(cons.STDERR, 'w')
        if platform.system() != 'Windows':
            os.mkfifo(cons.FIFO)
            file(cons.STDOUT, 'w')
        #[FIXME] How to do a FIFO with Windows?

    def __create_play_button(self):
        img_play_button = gtk.Image()
        if platform.system() == 'Windows':
            try:
                img_play_button.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.IMG_PATH, 'media-playback-start.png')))
            except: # Give a try with development path
                img_play_button.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.DEV_IMG_PATH, 'media-playback-start.png')))
        else:
            img_play_button.set_from_icon_name('media-playback-start', gtk.ICON_SIZE_MENU) # gtk.STOCK_MEDIA_PLAY = missing?
        self.play_button = gtk.Button()
        self.play_button.set_image(img_play_button)
        #self.play_button.set_relief(gtk.RELIEF_NONE)
        self.play_button.set_tooltip_text(_('Start playback'))
        self.play_button.connect('clicked', self.on_activate_pause)

    def __create_stop_button(self):
        img_stop_button = gtk.Image()
        img_stop_button.set_from_icon_name(gtk.STOCK_MEDIA_STOP, gtk.ICON_SIZE_MENU)
        self.stop_button = gtk.Button()
        self.stop_button.set_image(img_stop_button)
        #self.stop_button.set_relief(gtk.RELIEF_NONE)
        self.stop_button.set_tooltip_text(_('Stop playback'))
        self.stop_button.connect('clicked', self.on_activate_stop)

    def __create_streamVolumeButton(self):
        self.streamVolumeButton = gtk.VolumeButton()

        try:
            img_minus_button = gtk.Image()
            img_minus_button.set_from_icon_name(gtk.STOCK_REMOVE, gtk.ICON_SIZE_MENU)
            minus_button = self.streamVolumeButton.get_minus_button()
            minus_button.set_label('-')
            minus_button.set_image(img_minus_button)

            img_plus_button = gtk.Image()
            img_plus_button.set_from_icon_name(gtk.STOCK_ADD, gtk.ICON_SIZE_MENU)
            plus_button = self.streamVolumeButton.get_plus_button()
            plus_button.set_label('+')
            plus_button.set_image(img_plus_button)
        except AttributeError:
            print _('Error: fallback mode gtk.VolumeButton needs pygtk 2.16 for get_minus_button or get_plus_button')

        # [TODO] NOT WORKING! Have a bug with pygobject!
        #scale_button = self.streamVolumeButton.get_popup().get_child().get_child().get_children()
        #[<gtk.Button object at 0x8d28cd4 (GtkButton at 0x8dde760)>, <gtk.ScaleButtonScale object at 0x8d28824 (GtkScaleButtonScale at 0x8f0a060)>, <gtk.Button object at 0x8d28d4c (GtkButton at 0x8f06800)>]

        #print scale_button[1]
        """
        TypeError: Cannot create a consistent method resolution
        order (MRO) for bases ImplementorIface, Buildable, gtk.Orientable
        **
        ERROR:/build/buildd/pygobject-2.18.0/gobject/pygobject.c:924:pygobject_new_full: assertion failed: (tp != NULL)
        /usr/bin/tivion: line 5: 30042 Cancelado               python tivion.py $1 $2 $3 $4
        """

        #scale_button.set_digits(0)
        #scale_button.set_property("height-request", 160)
        #scale_button.set_value_pos(gtk.POS_BOTTOM)

        #print self.streamVolumeButton.get_minus_button()

    def __create_hbox_buttons(self):
        self.__create_play_button()
        self.__create_stop_button()
        self.__create_streamVolumeButton()

        hbox_buttons = gtk.HBox(0,True)
        hbox_buttons.set_border_width(0)
        hbox_buttons.pack_start(self.play_button, True, True, 0);
        hbox_buttons.pack_start(self.stop_button, True, True, 0)
        """
        vol_button = gtk.Button()
        icon_theme = gtk.icon_theme_get_default()
        icon_vol_medium = icon_theme.load_icon('audio-volume-medium', gtk.ICON_SIZE_MENU, gtk.ICON_LOOKUP_FORCE_SVG)
        img = gtk.Image()
        img.set_from_pixbuf(icon_vol_medium)
        #print dir(vol_button)
        vol_button.add(img)
        vol_button.connect('clicked', self.on_popup_volume)
        #hbox_buttons.pack_start(vol_button, True, True, 0); # [FIXME] Bug on popup
        """

        hbox_buttons.pack_start(self.streamVolumeButton , False, False, 0)
        return hbox_buttons

    def __combobox_channels_type(self):
        combobox = gtk.combo_box_new_text()
        for item in [_('All'), _('TV'), _('Radio'), _('Sopcast')]:
            combobox.append_text(item)
        combobox.connect('changed', self.on_changed_combobox)
        combobox.set_active(0)
        return combobox

    def __create_menubar(self):
        # load accel keys
        gtk.accel_map_load(self.accel_map_filename)

        # Accel group and action group
        accel_group = gtk.AccelGroup()
        action_group = gtk.ActionGroup('BasicAction')
        self.window.add_accel_group(accel_group)

        # File menubar items
        open_stream = u.ImageMenuItem(_('_Open stream'), gtk.STOCK_OPEN, self.on_open_stream, '<Ctrl>o', accel_group) # [TODO]
        exit        = u.ImageMenuItem(_('_Quit'), gtk.STOCK_QUIT, self.on_destroy_event, '<Ctrl>q', accel_group, _('_Quit'))
        menu_archive = u.make_menu([open_stream, gtk.SeparatorMenuItem(), exit])

        archive = gtk.MenuItem(_('_File'))
        archive.set_submenu(menu_archive)

        # Playback menubar item
        # play/pause action
        self.pause = gtk.Action(_('Pause/Resume'), _('_Pause/Resume'), _('_Pause/Resume'), 'media-playback-start')
        icon = self.pause.create_icon(gtk.ICON_SIZE_MENU)

        try:
            self.pause.set_icon_name('media-playback-start') #Require gtk 2.16; gtk.STOCK_MEDIA_PLAY => Missing image
        except AttributeError:
            if cons.DEBUG:
                print _('Warning: fallback mode gtk.Action needs pygtk 2.16 for set_icon_name: media-playback-start')
            try:
                icon.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.IMG_PATH, 'media-playback-start.png')))
            except: # Give a try with development path
                icon.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.DEV_IMG_PATH, 'media-playback-start.png')))

        self.pause.set_accel_group(accel_group)
        self.pause.set_property('short-label', _('_Pause/Resume'))
        action_group.add_action_with_accel(self.pause, '<Ctrl>space')
        self.pause.connect('activate',self.on_activate_pause)

        # Stop action
        stop    = u.ImageMenuItem(_('_Stop'), gtk.STOCK_MEDIA_STOP, self.on_activate_stop, '<Ctrl>s', accel_group)

        # Up volume action
        self.volume_up = gtk.Action(_('Volume Up'), _('Volume _Up'), _('Volume _Up'), 'audio-volume-high')
        icon = self.volume_up.create_icon(gtk.ICON_SIZE_MENU)
        try:
            self.volume_up.set_icon_name('audio-volume-high')

            if platform.system() == 'Windows':
                if cons.DEBUG:
                    print _('Warning: fallback mode gtk.Action needs pygtk 2.16 for set_icon_name: audio-volume-high')
                try:
                    icon.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.IMG_PATH, 'audio-volume-high.png')))
                except: # Give a try with development path
                    icon.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.DEV_IMG_PATH, 'audio-volume-high.png')))

        except AttributeError:
            if cons.DEBUG:
                print _('Warning: fallback mode gtk.Action needs pygtk 2.16 for set_icon_name: audio-volume-high')
            if icon:
                try:
                    icon.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.IMG_PATH, 'audio-volume-high.png')))
                except: # Give a try with development path
                    icon.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.DEV_IMG_PATH, 'audio-volume-high.png')))
            else:
                print 'NO ICON'

        self.volume_up.connect('activate',self.on_activate_volume_up)
        self.volume_up.set_accel_group(accel_group)
        action_group.add_action_with_accel(self.volume_up, '<Ctrl>Up')

        # Down volume action
        self.volume_down = gtk.Action(_('Volume Down'), _('Volume _Down'), _('Volume _Down'), 'audio-volume-low')
        self.volume_down.create_icon(gtk.ICON_SIZE_MENU)
        try:
            self.volume_down.set_icon_name('audio-volume-low')
        except AttributeError:
            if cons.DEBUG:
                print _('Warning: fallback mode gtk.Action needs pygtk 2.16 for set_icon_name: audio-volume-low')
            try:
                icon.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.IMG_PATH, 'audio-volume-low.png')))
            except: # Give a try with development path
                icon.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.DEV_IMG_PATH, 'audio-volume-low.png')))

        self.volume_down.connect('activate',self.on_activate_volume_down)
        self.volume_down.set_accel_group(accel_group)
        action_group.add_action_with_accel(self.volume_down, '<Ctrl>Down')

        ontop    = u.ImageMenuItem(_('_Window on top'), gtk.STOCK_GOTO_TOP, self.on_activate_ontop, 'F10', accel_group)

        if platform.system() != 'Windows':
            icon_theme = gtk.icon_theme_get_default()
            try:
                icon_camera = icon_theme.load_icon('camera-photo', gtk.ICON_SIZE_MENU, gtk.ICON_LOOKUP_FORCE_SVG) # gtk.ICON_LOOKUP_USE_BUILTIN
            except Exception, e: #gobject.GError
                print _("Can't load icon: "), e

        #capture = gtk.ImageMenuItem('Take screenshoot')
        #capture.get_image().set_from_pixbuf(icon_camera)

        # capture menu item
        capture = gtk.Action(_('Take screenshot'), _('_Take screenshot'), _('Take screenshot'), 'camera-photo')
        icon = capture.create_icon(gtk.ICON_SIZE_MENU)
        capture.set_property('short-label', _('_Take screenshot'))
        action_group.add_action_with_accel(capture, '<Ctrl>t')
        capture.connect('activate',self.on_capture_screen)
        capture.set_accel_group(accel_group)

        try:
            if platform.system() == 'Windows':
                if cons.DEBUG:
                    print _('Warning: fallback mode gtk.Action needs pygtk 2.16 for set_icon_name: camera-photo')
                try:
                    icon.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.IMG_PATH, 'camera-photo.png')))
                except: # Give a try with development path
                    icon.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.DEV_IMG_PATH, 'camera-photo.png')))

            capture_item = capture.create_menu_item()
        except AttributeError: # For versions lower to pygtk 2.16
            capture.set_menu_item_type(gtk.ImageMenuItem)
            capture_item = capture.create_menu_item()
            capture_item.set_image(gtk.image_new_from_icon_name('camera-photo', gtk.ICON_SIZE_MENU))
        except:
            if cons.DEBUG:
                print _('Warning: fallback mode gtk.Action needs pygtk 2.16 for set_icon_name: camera-photo')
            try:
                capture_item.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.IMG_PATH, 'camera-photo.png')))
            except: # Give a try with development path
                capture_item.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.DEV_IMG_PATH, 'camera-photo.png')))


        # go fullscreen action
        go_fullscreen = gtk.Action(_('Fullscreen'), _('_Fullscreen'), _('Fullscreen'), gtk.STOCK_FULLSCREEN)
        go_fullscreen.create_icon(gtk.ICON_SIZE_MENU)
        go_fullscreen.set_property('short-label', _('_Fullscreen'))
        go_fullscreen.connect('activate', self.on_activate_fullscreen) # Connect a callback to the action
        go_fullscreen.set_accel_group(accel_group)
        action_group.add_action_with_accel(go_fullscreen, 'F11')

        modify_channels = u.ImageMenuItem(_('_Modify channels'), gtk.STOCK_EDIT,
                                          None, '<Ctrl>m', accel_group) #[TODO]

        # view channellist  checkmenuitem
        self.viewChannels = gtk.CheckMenuItem(_('_View channel list'))
        self.viewChannels.set_active(True)
        key, mod = gtk.accelerator_parse('F9')
        self.viewChannels.add_accelerator('activate', accel_group, key, mod, gtk.ACCEL_VISIBLE)
        self.viewChannels.connect('activate', self.on_viewChannels)
        #self.viewChannels.connect("key_press_event", self.on_viewChannels)

        setting = u.ImageMenuItem(_('_Preferences'), gtk.STOCK_PREFERENCES, self.on_activate_configuration, '<Ctrl>p', accel_group)

        menu_edit = u.make_menu([ontop, go_fullscreen.create_menu_item(),
                        gtk.SeparatorMenuItem(), self.viewChannels,
                        modify_channels, gtk.SeparatorMenuItem(),
                        capture_item, gtk.SeparatorMenuItem(),
                        setting])

        edit = gtk.MenuItem(_('_Edit'))
        edit.set_submenu(menu_edit)

        menu_sound = u.make_menu([self.pause.create_menu_item(), stop,
                                gtk.SeparatorMenuItem(),
                                self.volume_up.create_menu_item(),
                                self.volume_down.create_menu_item()])

        sound = gtk.MenuItem(_('_Sound'))
        sound.set_submenu(menu_sound)

        about          = u.ImageMenuItem(_('_About %s') % cons.VERSION,
                                         gtk.STOCK_ABOUT, self.on_about)
        help_man       = u.ImageMenuItem(_('_Index'), gtk.STOCK_HELP,
                                         None, #self.on_help_man
                                         'F1', accel_group)
        if platform.system() == 'Windows':
            try:
                lpi_help = gtk.gdk.pixbuf_new_from_file(os.path.join(cons.IMG_PATH, 'lpi-help.png'))
            except: # Give a try with development path
                lpi_help = gtk.gdk.pixbuf_new_from_file(os.path.join(cons.DEV_IMG_PATH, 'lpi-help.png'))
        else:
            lpi_help = 'lpi-help'
        help_online    = u.ImageMenuItem(_('_Get help online'), lpi_help,
                                         self.on_help_online)

        if platform.system() == 'Windows':
            try:
                lpi_translate = gtk.gdk.pixbuf_new_from_file(os.path.join(cons.IMG_PATH, 'lpi-translate.png'))
            except: # Give a try with development path
                lpi_translate = gtk.gdk.pixbuf_new_from_file(os.path.join(cons.DEV_IMG_PATH, 'lpi-translate.png'))
        else:
            lpi_translate = 'lpi-translate'
        translate_app  = u.ImageMenuItem(_('_Translate this application'),
                                         lpi_translate, self.on_translate_app)

        if platform.system() == 'Windows':
            try:
                lpi_bug = gtk.gdk.pixbuf_new_from_file(os.path.join(cons.IMG_PATH, 'lpi-bug.png'))
            except: # Give a try with development path
                lpi_bug = gtk.gdk.pixbuf_new_from_file(os.path.join(cons.DEV_IMG_PATH, 'lpi-bug.png'))
        else:
            lpi_bug = 'lpi-bug'
        report_problem = u.ImageMenuItem(_('_Report a problem'), lpi_bug,
                                         self.on_report_problem)


        menu_help = u.make_menu([help_man, gtk.SeparatorMenuItem(), help_online,
                               translate_app, report_problem,
                               gtk.SeparatorMenuItem(), about])

        help = gtk.MenuItem(_('_Help'))
        help.set_submenu(menu_help)

        menubar = gtk.MenuBar()
        for item in [archive, edit, sound, help]:
            menubar.append(item)

        return menubar

    def init_for_help(self, application_dir="/"):
        props = { gnome.PARAM_APP_DATADIR : os.path.join(application_dir,
                    'usr/share/tivion') }
        gnome.program_init('tivion', '0.0.3', properties=props)

    def display_help(self, help_id=None):
        if help_id != None:
                gnome.help_display('tivion', link_id=help_id)
        else:
                gnome.help_display('tivion')

    def on_translate_app(self, widget):
        gnome.help_display_uri('https://translations.launchpad.net/tivion/trunk/+pots/tivion')

    def on_help_online(self, widget):
        gnome.help_display_uri('https://answers.launchpad.net/tivion')

    def on_report_problem(self, widget):
        gnome.help_display_uri('https://bugs.launchpad.net/tivion/+filebug')

    def on_help_man(self, widget):
        #self.init_for_help()
        #self.display_help()
        #import gnome
        #gnome.help_display_uri('https://translations.launchpad.net/tivion/trunk/+pots/tivion')
        """import gnome.ui
        print gnome.program_init(cons.VERSION_NAME, cons.VERSION_NUMBER)
        client = gnome.ui.master_client()
        print client
        command = os.path.normpath(os.path.join(os.getcwd(), sys.argv[0]))
        print command
        client.set_restart_style(gnome.ui.RESTART_IF_RUNNING)
        try: client.set_restart_command([command] + sys.argv[1:])
        except TypeError:
            client.set_restart_command(len(sys.argv), [command] + sys.argv[1:])
        client.connect('die', gtk.main_quit)"""
        pass

    def __create_statusbar(self, initial = True):
        statusbar = gtk.Statusbar()
        statusbar.set_property('height_request', 20)
        if initial:
            context_id = statusbar.get_context_id('statusbar main')
            self.last_msg_pushed = _('%s loaded.') % cons.VERSION
            statusbar.push(context_id, self.last_msg_pushed)
        return statusbar

    def push_status(self, msg):
        context_id = self.statusbar.get_context_id('statusbar main')
        self.last_msg_pushed = msg
        self.statusbar.push(context_id, msg)

    def pop_status(self):
        context_id = self.statusbar.get_context_id('statusbar main')
        self.statusbar.pop(context_id)

    def _execute(self, command, parseValue=False):
        """
        Executes a command, flush the buffer and
        optionally returns the value from the key-value
        raw value given by MPlayer
        """
        if platform.system() != 'Windows':
            try:
                self.proc.stdin.write('%s\n' % command)
                self.proc.stdin.flush()
            except Exception, e:
                print 'PROC ERROR', e

        answer = ""
        """line = self.progressLog.readline()

        if line:
            if parseValue:
                if cons.DEBUG:
                    print _('Line: ') , line
                #answer = line[line.index('=')+1:-1]
            else: answer = line
        """
        return answer

    def stream_slider_changed(self,range,widget,new_value):
        #self.updateAppTooltip(self.pulseSink.client.name, new_value)
        #self.volumeAdjust.set_value(int(new_value))
        print int(new_value)
        return True

    def on_popup_volume(self, widget):
        volumeAdjust = gtk.Adjustment(self.volume, 0, 100, -5)
        streamVolume = gtk.VScale(volumeAdjust)
        streamVolume.set_digits(0)
        streamVolume.set_property("height-request", 160)
        streamVolume.set_value_pos(gtk.POS_BOTTOM)
        streamVolume.connect("change-value",self.stream_slider_changed)

        muteButton = gtk.Button()
        muteButtonIcon = gtk.Image()
        muteButtonIcon.set_from_icon_name('audio-volume-muted', gtk.ICON_SIZE_MENU)
        muteButton.set_property("can-focus", False)
        muteButton.set_image(muteButtonIcon)
        muteButton.set_relief(gtk.RELIEF_NONE)

        add_button = gtk.Button()
        add_button = gtk.Image()
        add_button.set_from_icon_name(gtk.STOCK_ADD, gtk.ICON_SIZE_MENU)

        remove_button = gtk.Button()
        remove_button = gtk.Image()
        remove_button.set_from_icon_name(gtk.STOCK_REMOVE, gtk.ICON_SIZE_MENU)

        vbox = gtk.VBox(0, True)
        vbox.set_border_width(0)
        vbox.pack_start(muteButton, False, False, 0)
        vbox.pack_start(add_button, False, False, 0)
        vbox.pack_start(streamVolume, True, True, 0)
        vbox.pack_start(remove_button, False, False, 0)

        self.window_popup = gtk.Window(gtk.WINDOW_POPUP)
        self.window_popup.set_position(gtk.WIN_POS_MOUSE)
        self.window_popup.add(vbox)

        self.window_popup.connect("scroll-event", self.stream_scroll_event)
        self.window_popup.show_all()

    def stream_scroll_event(self, widget, event):
        ##print "entro"
        """volume = self.volumeAdjust.get_value()

        if event.direction == gtk.gdk.SCROLL_UP or \
           event.direction == gtk.gdk.SCROLL_RIGHT:
          volume += 10
        elif event.direction == gtk.gdk.SCROLL_DOWN or \
             event.direction == gtk.gdk.SCROLL_LEFT:
          volume -= 10

        if volume > 100:
          volume = 100
        elif volume < 0:
          volume = 0

        #self.updateAppTooltip(self.pulseSink.client.name, volume)
        self.volumeAdjust.set_value(volume)
        """
        return True

    def on_about(self, widget):
        about = gtk.AboutDialog()
        about.set_transient_for(self.window)
        about.set_program_name("Tivion")
        about.set_version(cons.VERSION_NUMBER)
        about.set_copyright("Copyright (C) 2009 Ángel Guzmán Maeso (Shakaran) <shakaran@gmail.com>")
        about.set_authors(['Ángel Guzmán Maeso (Shakaran) <shakaran@gmail.com>'])
        about.set_artists(['Ángel Guzmán Maeso (Shakaran) <shakaran@gmail.com>'])
        about.set_documenters(['Ángel Guzmán Maeso (Shakaran) <shakaran@gmail.com>'])
        about.set_comments('')
        try:
            about.set_license(open(cons.license_filename).read())
        except:
            about.set_license(_("GNU General Public License version 3 or later.\nSee http://www.gnu.org/licenses/gpl-3.0.txt"))
        about.set_comments(_('A single player and recorder for streaming online television and radio channels composed of multicultural and international level.'))
        about.set_website('http://www.shakaran.es/blog/tivion')
        about.set_website_label('Tivion website (shakaran.es)')
        about.set_name('Tivion')
        gtk.about_dialog_set_email_hook(self.on_email)
        gtk.about_dialog_set_url_hook(self.on_url)
        try:
            about.set_logo(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.IMG_PATH, 'tivion.png')))
        except: # Give a try with development path
             about.set_logo(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.DEV_IMG_PATH, 'tivion.png')))
        """
        TRANSLASTORS: Maintain the names of translators here.
        Launchpad does this automatically for translations
        typed in Launchpad. This is a special string shown
        in the 'About' box.
        """
        about.set_translator_credits(_('translator-credits'))
        about.run()
        about.destroy()

    def on_email(self, dialog, mail):
        gtk.show_uri(None, 'mailto:' + mail, 0)

    def on_url(self, dialog, link):
        gtk.show_uri (None, link, 0)

    def on_changed_combobox(self, combobox):
        model = combobox.get_model()
        index = combobox.get_active()

        if index != None:
            if model[index][0] == 'TV':
                self.__insert_channels(cons.TV)
            elif model[index][0] == 'Radio':
                self.__insert_channels(cons.RADIO)
            elif model[index][0] == 'Sopcast':
                self.__insert_channels(cons.SOPCAST)
            elif model[index][0] == 'All':
                self.__insert_channels(None)

        return

    def get_lang(self, index):
        for (lang, ulang, name) in self.found_lang:
            if name == index:
                return (lang, ulang, name)

    def on_changed_language(self, combobox):
        global _, gettext, cur_locale
        destroywin = False
        model = combobox.get_model()
        index = combobox.get_active()

        (lang, ulang, name) = self.get_lang(model[index][0])
        print os.environ['LANG']
        os.environ['LANG'] = ulang # Dont work with os.putenv('LANG', ulang)
        print os.environ['LANG']
        cur_locale = locale.setlocale(locale.LC_ALL, None)
        t = gettext.translation('tivion', languages=[lang])
        t.install()
        _ = t.lgettext

        md = gtk.MessageDialog(self.wconfig,
            gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_QUESTION,
            0, _('Do you want reload the application for apply language changes?'))
        #md.set_default_size(200, 200)
        md.set_modal(True)
        md.set_title(_('Apply changes'))
        self.window.set_sensitive(False)
        self.wconfig.set_sensitive(False)
        md.set_position(gtk.WIN_POS_CENTER)
        md.add_button(gtk.STOCK_YES, gtk.RESPONSE_OK)
        md.add_button(gtk.STOCK_NO, gtk.RESPONSE_CANCEL)
        md.set_default_response(gtk.RESPONSE_CANCEL)

        response = md.run()

        if response == gtk.RESPONSE_OK:
            vbox = self.window.get_children()[0]
            vbox.get_children()[0].destroy() # Destroy menubar
            self.menubar = self.__create_menubar()
            vbox.pack_start(self.menubar, False, False, 0)
            vbox.reorder_child(self.menubar, 0)

            """ [TODO] Update the right channel zone
            hbox = vbox.get_children()[1]
            hbox_buttons = self.vbox_panel.get_children()[2] # Buttons
            self.vbox_panel.destroy() # Destroy combobox, treestore and buttons

            self.vbox_panel = gtk.VBox(0, True)
            self.vbox_panel.set_border_width(0)
            self.vbox_panel.pack_start(self.__combobox_channels_type() , False, True, 0)
            #self.vbox_panel.pack_start(self.sw, True, True, 0)
            self.vbox_panel.pack_startself.vbox_panel.pack_start(hbox_buttons, False, False, 0)
            hbox.pack_end(self.vbox_panel, expand=False, fill=True, padding=0)
            #hbox.reorder_child(self.vbox_panel, 1)

            #print subhbox.get_children()[1].get_children()[0].get_children()
            #subhbox.get_children()[0].destroy() # Combobox channels
            #subhbox.get_children()[1].get_children()[0].destroy() # Viewport
            #subhbox.get_children()[1].destroy() # Scrolled window
            """

            vbox.get_children()[2].destroy() # Destroy statusbar
            self.statusbar = self.__create_statusbar(False)
            self.push_status( _('%s loaded.') % cons.VERSION)
            vbox.pack_end(self.statusbar, False, False, 0)
            vbox.reorder_child(self.statusbar, 2)

            destroywin = True

            self.menubar.show()
            self.window.show_all()

        self.window.set_sensitive(True)
        self.wconfig.set_sensitive(True)
        md.destroy()

        if destroywin:
            self.wconfig.hide()

        return

    def on_key_press_event(self, widget, event):
        if event.string == 'q' :
            wfocus = self.window.get_focus()
            if wfocus.__class__ != u.entrySearch:
                self.on_destroy()

        if cons.DEBUG:
            keyname = gtk.gdk.keyval_name(event.keyval)
            print _('Key pressed: '), keyname

    def toggle_channel_list(self, widget):
        if self.vbox_panel.get_property('visible'):
            self.viewChannels.set_active(False)
            self.vbox_panel.hide()
        else:
            self.viewChannels.set_active(True)
            self.vbox_panel.show()

    def on_viewChannels(self, widget):
        if self.vbox_panel.get_property('visible'):
            self.vbox_panel.hide()
        else:
            self.vbox_panel.show()

    def on_wconfig_destroy(self, widget, other = None):
        widget.destroy()
        self.window.set_sensitive(True)

    def on_wstream_destroy(self, widget, other = None):
        widget.destroy()
        self.window.set_sensitive(True)

    def on_activate_configuration(self, widget):
        self.wconfig = gtk.Window()
        self.wconfig.set_position(gtk.WIN_POS_CENTER_ON_PARENT)
        self.wconfig.set_transient_for(self.window)
        self.wconfig.set_title(_('Configuration'))
        self.wconfig.set_default_size(250, 320)
        self.wconfig.set_border_width(5)
        self.wconfig.connect("delete_event", self.on_wconfig_destroy)
        self.wconfig.connect("destroy_event", self.on_wconfig_destroy)
        self.wconfig.connect("destroy", self.on_wconfig_destroy)
        self.window.set_sensitive(False)

        vbox = gtk.VBox(0, True)
        vbox.set_border_width(0)

        (user_locale, user_locale_encode) = locale.getdefaultlocale()

        cur_locale = '%s-%s' % (user_locale, user_locale_encode)

        label = gtk.Label(_('Language: '))
        ###label.set_line_wrap(True) #break lines

        self.supported_languages = [
                                ('en',    'en_US.UTF-8',   _('English')),
                                ('en_GB', 'en_GB.UTF-8',   _('English (United Kingdom)')),
                                ('fr',    'fr_FR.UTF-8',   _('French')),
                                ('es',    'es_ES.UTF-8',   _('Spanish')),
                                ('es_AR', 'es_AR.UTF-8',   _('Spanish (Argentina)')),
                                ('ca',    'ca_ES.UTF-8',   _('Catalan')),
                                ('it',    'it_IT.UTF-8',   _('Italian')),
                                ('pt',    'pt_PT.UTF-8',   _('Portuguese')),
                                ('pt_BR', 'pt_BR.UTF-8',   _('Portuguese (Brazil)')),
                                ('ru',    'ru_TU.UTF-8',   _('Russian')),
                                ('tr',    'tr_TR.UTF-8',   _('Turkish')),
                                ('af',    'af_AF.UTF-8',   _('Afrikaans')),
                                ('ar',    'ar_AR.UTF-8',   _('Aragonese')),
                                ('tr',    'tr_TR.UTF-8',   _('Arabic')),
                                ('bs',    'bs_BS.UTF-8',   _('Bosnian')),
                                ('el',    'el_EL.UTF-8',   _('Greek')),
                                ('en_AU', 'en_AU.UTF-8',   _('English (Australia)')),
                                ('eu',    'eu_EU.UTF-8',   _('Basque')),
                                ('sq',    'sq_SQ.UTF-8',   _('Albanian')),
                                ('tlh',   'tlh_TLH.UTF-8', _('Klingon')),
                                ('zh_TW', 'zh_TW.UTF-8',   _('Chinese (Traditional)')),
                                ('de',    'de_DE.UTF-8',   _('German')),
                                ('gl',    'es_GL.UTF-8',   _('Galician')),
                                ('hr',    'hr_HR.UTF-8',   _('Croatian')),
                                ('ar',    'ar_AR.UTF-8',   _('Arabic')),
                                ('ast',   'ast_AST.UTF-8', _('Asturian')),
                                ('bg',    'bg_BG.UTF-8',   _('Bulgarian')),
                                ('oc',    'oc_OC.UTF-8',   _('Occitan (post 1500)'))
                              ]

        # Other option: gettext.find('tivion', cons.LOCALE_DIR, ['es', 'en'], 'All')
        self.found_lang = []
        for (lang, ulang, name) in self.supported_languages:
            path = '/usr/share/locale/%s/LC_MESSAGES/tivion.po' % lang
            if os.path.exists(path) and os.path.isfile(path):
                if cons.DEBUG:
                    print _('Found language: \'%s\'' %lang) + ('(%s) in' %name) + ('%s' %path)
                self.found_lang.append((lang, ulang, name))

        combobox = gtk.combo_box_new_text()
        if not self.found_lang:
            combobox.append_text(_('English'))
            combobox.set_active(0)
        else:
            i = 0
            for (lang, ulang, name) in self.found_lang:
                combobox.append_text(name)
                if ulang == os.getenv('LANG'):
                    combobox.set_active(i)
                i += 1

        combobox.connect('changed', self.on_changed_language)

        hbox = gtk.HBox(0, True)
        hbox.set_border_width(0)

        hbox.pack_start(label, False, False, 0)
        hbox.pack_start(combobox, False, False, 0)

        hbox_ss = gtk.HBox(0, True)
        hbox_ss.set_border_width(0)

        ss_btn = gtk.FileChooserButton(_('Select a folder'))
        ss_btn.set_current_folder(self.get_ss_folder())
        ss_btn.set_action(gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)
        ss_btn.set_size_request(120, -1)
        ss_btn.set_show_hidden(True)
        ss_btn.connect('current-folder-changed', self.on_ss_selected)

        hbox_ss.pack_start(gtk.Label(_('Screenshot folder:')), False, False, 0)
        hbox_ss.pack_start(ss_btn, False, False, 0)

        self.scale = gtk.HScale()
        self.scale.set_range(32, 8192)
        self.scale.set_digits(0)
        self.scale.set_size_request(160, 35)
        self.scale.set_value(self.get_cache_size())
        self.scale.set_inverted(False)
        self.scale.connect('value-changed', self.on_changed_cache_scale)

        hbox_cache = gtk.HBox(0, True)
        hbox_cache.set_border_width(0)
        hbox_cache.pack_start(gtk.Label(_('Cache size:')), False, False, 0)
        hbox_cache.pack_start(self.scale, True, False, 0)

        button = u.ButtonUnLabeled(stock = gtk.STOCK_CLEAR)
        button.set_tooltip_text(_('Restore cache size value'))
        button.connect('clicked', self.on_changed_cache_button)

        hbox_cache.pack_start(button, True, False, 0)

        check_box_rand = gtk.CheckButton(
                            label = _('_Open a random channel at the beginning'),
                            use_underline = True)
        check_box_rand.set_active(self.get_random_channel_state())
        check_box_rand.connect('clicked', self.on_changed_random_channel)

        vbox.pack_start(hbox, False, False, 0)
        vbox.pack_start(hbox_ss, False, False, 0)
        vbox.pack_start(hbox_cache, False, False, 0)
        vbox.pack_start(check_box_rand, False, False, 0)

        self.wconfig.add(vbox)
        self.wconfig.show_all()

    def on_changed_cache_button(self, widget):
        cache = cons.DEFAULT_CACHE_SIZE
        if cons.DEBUG:
            print _('Cache size:'), cache
        self.scale.set_value(cache)
        cfg.cfg.set('OPTIONS', 'Cache_size', str(cache))
        cfg.write()
        return True

    def on_changed_random_channel(self, widget):
        state = widget.get_active()
        if cons.DEBUG:
            print _('Setting open random channel at the beginning to: %s' % state)

        cfg.cfg.set('OPTIONS', 'Random_channel', str(int(state)))
        cfg.write()
        return True

    def get_random_channel_state(self):
        state = cfg.cfg.get('OPTIONS', 'Random_channel')
        if state == None:
            state = 0
        return int(state)

    def on_changed_cache_scale(self, widget):
        cache = int(float(widget.get_value()))
        if cons.DEBUG:
            print _('Cache size:'), cache
        if not cache:
            cache = cons.DEFAULT_CACHE_SIZE
        if cache < 32 or cache > 8192:
            cache = cons.DEFAULT_CACHE_SIZE
        cfg.cfg.set('OPTIONS', 'Cache_size', str(cache))
        cfg.write()
        return True

    def get_cache_size(self):
        cfg_cache_size = cfg.cfg.get('OPTIONS', 'Cache_size')
        if not cfg_cache_size:
            cfg_cache_size = cons.DEFAULT_CACHE_SIZE
        cfg_cache_size = int(float(cfg_cache_size))
        if cfg_cache_size < 32 or cfg_cache_size > 8192:
            cfg_cache_size = cons.DEFAULT_CACHE_SIZE
        return int(cfg_cache_size)

    def check_ss_dir(self):
        u.check_dir(self.ss_dir)

    def get_ss_folder(self):
        ss_folder = cfg.cfg.get('OPTIONS', 'Screenshot_folder')
        if not ss_folder:
            ss_folder = self.ss_dir
        return ss_folder

    def on_ss_selected(self, widget):
        filename = widget.get_filename()
        if cons.DEBUG:
            print _('Screenshot folder:'), filename
        cfg.cfg.set('OPTIONS', 'Screenshot_folder', filename)
        cfg.write()

    def on_activate_stop(self, widget):
        if self.isPlaying or self.isPaused and not self.isStop: # [FIXME] The mplayer windows is frozen here.
            self._execute('stop')
            self.isStop = True
            self.isPlaying = False
            self.sc.isStop = True
            self.isPaused = False
            self.cleanArea = False
            self.push_status(_('Stopped: %s') % self.currentNameChannel)
            self.progressbar.hide()

            if hasattr(self, 'sc'):
                self.sc.quit = True
            if hasattr(self, 'sp_thread'):
                self.sp_thread.quit = True
            if hasattr(self, 'proc'):
                self._execute('quit\n')
                self.proc.stdin.close()
                u.pterminate(self.proc)
        else:
             self.push_status(_('Nothing playing!'))

    def on_activate_fullscreen(self, widget):
        if self.winfullscreen == False:
            #window1.set_decorated(gtk.FALSE)
            self.window.fullscreen()
            # X11 need this, OpenGL not
            #self.videoArea.set_size_request(-1,-1)
            #self._execute('vo_fullscreen')
        else:
            self.window.unfullscreen()
        self.winfullscreen = not self.winfullscreen

    def on_activate_ontop(self, widget): #  Window.present() and Window.set_keep_above()
        if self.isPlaying and not self.isStop: # [FIXME] Dont working!, debe ser por pygtk que usa la window
            self.keepAbove = not self.keepAbove
            self.window.set_keep_above(self.keepAbove)
            self._execute('vo_ontop')
        else:
             self.push_status(_('Nothing playing!'))

    def on_activate_volume_up(self, widget): # [FIXME] Hacer un deslizable + teclas arriba y abajo
        if self.isPlaying and not self.isStop:
            self.volume = self.volume + 10
            if self.volume > 100:
                self.volume = 100;
            self._execute('volume %s 1' % self.volume)
        else:
             self.push_status(_('Nothing playing!'))

    def on_activate_volume_down(self, widget):
        if self.isPlaying and not self.isStop:
            self.volume = self.volume - 10
            if self.volume < 0:
                self.volume = 0;
            self._execute('volume %s 1' % self.volume)
        else:
             self.push_status(_('Nothing playing!'))

    def on_capture_screen(self, widget): # [FIXME] Hacer el menos y tambien un deslizable + teclas
        if self.isPlaying:
            import gst
            time.sleep(.3) # For avoid capture the menu and mix frames (slow graphic cards)
            self.pipeline = gst.Pipeline("mypipeline")

            #def snap_shot(self,widget,data=None):
            #global file_loc   ,pixbuf
            self.pipeline.set_state(gst.STATE_PAUSED)
            alloc = self.videoArea.get_allocation()
            pixbuf = gtk.gdk.Pixbuf( gtk.gdk.COLORSPACE_RGB, False, 8, alloc.width, alloc.height)
            pixbuf.get_from_drawable(self.videoArea.window, self.videoArea.get_colormap(), 0, 0, 0, 0, alloc.width, alloc.height)

            self.ss_dir = self.get_ss_folder()
            self.check_ss_dir()
            file_loc = self.ss_dir  + '/tivion-' + _('capture') + '-%d.jpg' % time.time()
            pixbuf.save(file_loc,'jpeg', {'quality':'100'})
            print _('Screenshot file stored in: %s') % file_loc
            self.pipeline.set_state(gst.STATE_PLAYING)
        else:
             self.push_status(_('Tivion could not make a capture. Nothing playing!'))

    def on_activate_pause(self, widget):
        if self.isPlaying:
            self.isStop = False
            self.pop_status()
            if self.isPaused == True:
                self.isPaused = False
                if self.currentNameChannel != None:
                    self._execute('pause', False)
                    self.push_status(_('Playing: %s') % self.currentNameChannel)
                    if platform.system() == 'Windows':
                        try:
                            self.pause.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.IMG_PATH, 'media-playback-start.png')))
                        except: # Give a try with development path
                            self.pause.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file(os.path.join(cons.DEV_IMG_PATH, 'media-playback-start.png')))
                    else:
                         self.pause.set_icon_name('media-playback-start') #gtk.STOCK_MEDIA_PLAY => Missing image

                    self.pause.set_icon_name('media-playback-start') #gtk.STOCK_MEDIA_PLAY => Missing image
                    img_play_button = gtk.Image()
                    img_play_button.set_from_icon_name('media-playback-start', gtk.ICON_SIZE_MENU) # 'media-playback-start'
                    self.play_button.set_image(img_play_button)
                    self.play_button.set_tooltip_text(_('Start playback'))
                else:
                    self.push_status(_('Nothing to play!'))

            elif self.isPaused == False:
                self.isPaused = True
                if self.currentNameChannel != None:
                    self._execute('pause', False)
                    self.push_status(_('Paused: %s') % self.currentNameChannel)
                    self.pause.set_icon_name(gtk.STOCK_MEDIA_PAUSE)
                    img_play_button = gtk.Image()
                    img_play_button.set_from_icon_name(gtk.STOCK_MEDIA_PAUSE, gtk.ICON_SIZE_MENU) # 'media-playback-start'
                    self.play_button.set_image(img_play_button)
                    self.play_button.set_tooltip_text(_('Resume playback'))
                else:
                    self.push_status(_('Nothing to pause!'))
        else:
            self.push_status(_('Nothing playing!'))

    def on_open_stream(self, widget):
        self.wstream = gtk.Window()
        self.wstream.set_position(gtk.WIN_POS_CENTER_ON_PARENT)
        self.wstream.set_transient_for(self.window)
        self.wstream.set_title(_('Open stream'))
        self.wstream.set_default_size(250, 120)
        self.wstream.set_border_width(5)
        self.wstream.connect("delete_event", self.on_wstream_destroy)
        self.wstream.connect("destroy_event", self.on_wstream_destroy)
        self.wstream.connect("destroy", self.on_wstream_destroy)
        self.window.set_sensitive(False)

        vbox = gtk.VBox(0, True)
        vbox.set_border_width(0)

        label = gtk.Label(_('Open a stream:') + 'NOT IMPLEMENTED YET')

        vbox.pack_start(label, False, False, 0)

        self.wstream.add(vbox)
        self.wstream.show_all()

    def on_destroy(self, widget = None):
        if hasattr(self,'mplayerClient'):
            try:
                self.mplayerClient.stdin.write('quit\n')
                self.mplayerClient.stdin.flush()
                self.mplayerClient.stdin.close()
                u.pterminate(self.mplayerClient)
            except AttributeError, ValueError: # [FIXME] This need a fix: #ValueError: I/O operation on closed file
                pass

        try:
            if hasattr(self,'proc'):
                if platform.system() != 'Windows':
                    if self.proc.stdin:
                        if not self.proc.stdin.closed:
                            self.proc.stdin.write('quit\n')
                            self.proc.stdin.flush()
                            self.proc.stdin.close()
                        u.pterminate(self.proc)
                else: u.pterminate(self.proc)
        except AttributeError, ValueError: # [FIXME] Maybe check this
            pass

        try:
            if hasattr(self,'sc'):
                self.sc.quit = True
        except AttributeError:
            pass

        try:
            if hasattr(self, 'sp_thread'):
                self.sp_thread.quit = True
        except AttributeError:
            pass

        if platform.system() != 'Windows':
            if os.path.exists(cons.FIFO):
                os.unlink(cons.FIFO)

        if platform.system() != 'Windows':
            if os.path.exists(cons.STDOUT):
                os.unlink(cons.STDOUT)

        if platform.system() != 'Windows':
            if os.path.exists(cons.STDERR):
                os.unlink(cons.STDERR)

        if platform.system() != 'Windows':
            if hasattr(self, 'proc'):
                u.pterminate(self.proc)

        # save accel map
        gtk.accel_map_save(self.accel_map_filename)

        gtk.main_quit()
        return False

    def on_delete_event(self, widget, data = None):
        return self.on_destroy()

    def on_destroy_event(self, widget, data = None):
        return self.on_destroy()

    def check_parsing(self, url):
        if url[0:6] == 'FILMON':
            if cons.DEBUG:
                print _('Parsing FILMON url: %s' % url[6:8])

            url = self.parseFilmon(url[6:8])
        elif url == 'A3':
            if cons.DEBUG:
                print _('Parsing A3 url')
            url = self.__parseA3URL()
        return url

    def get_data_channel_from_model(self, iter, model):
        name = model.get_value(iter, cons.COLUMN_NAME)
        country = model.get_value(iter, cons.COLUMN_COUNTRY)
        url = model.get_value(iter, cons.COLUMN_URL)
        channel_type = model.get_value(iter, cons.COLUMN_TYPE)
        format_type = model.get_value(iter, cons.COLUMN_FORMAT_TYPE)
        return (name, country, url, channel_type, format_type)

    def execute_channel(self, id, country, name, url, format_type, channel_type):
        print 'ID:', id, country, name, url, format_type
        self.currentNameChannel = name

        if format_type == cons.ASX:
            url = u.ASX_parser(url)
            if cons.DEBUG:
                print _('ASX url decoded to:'), url

        if url:
            url = self.check_parsing(url)

        if url != None:
            if self.isPlaying == True and channel_type != cons.SOPCAST:
                #try:
                self._execute("loadfile '%s' 0\n" % url,False)
                self.push_status(_('Playing: %s') % name)
                if hasattr(self, 'sc'):
                    self.sc.init_channel = False
                    # Add callback for progressbar
                self.timer = gobject.timeout_add(100, self.progress_timeout, self)
                #except IOerror: # [FIXME] flush() falling if dont have internet connection
                #    print 'IOerror'

                #self.proc.terminate()

                #if os.path.exists(FIFO):
                #    os.unlink(FIFO)

                #if os.path.exists(STDOUT):
                #    os.unlink(STDOUT)
            else:
                command = None
                sp_command = None
                play_ok = True
                cache = int(self.get_cache_size())
                # -hardframedrop, -mc
                if platform.system() == 'Windows':
                    self.xid = '-wid %s' % str(self.videoArea.window.handle)
                else:
                    self.xid = '-wid %s' % str(self.videoArea.window.xid)

                if channel_type == cons.SOPCAST:
                    if self.isPlaying == True: # Kill others TV, Radio o Sopcast channels
                        self.sc.quit = True
                        if hasattr(self, 'sp_thread'): # Maybe not sopcast (TV or Radio only)
                            self.sp_thread.quit = True
                        self.proc.stdin.write('quit\n')
                        self.proc.stdin.flush()
                        self.proc.stdin.close()
                        u.pterminate(self.proc)
                    if not u.check_sopcast_player():
                        print _('Error: sp-sc-auth could not found on library path')
                        play_ok = False
                    else:
                        # [TODO] Move this to a shell script for autoupdate sopcast player
                        # wget http://download.sopcast.cn/download/sp-auth.tgz
                        # wget http://www.sopcast.com/download/libstdcpp5.tgz
                        # tar -xvf libstdcpp5.tgz
                        # cd usr/lib
                        # sudo cp -a libstdc++.so.5* /usr/lib

                        # Sopcast: /usr/bin/sp-auth/sp-sc-auth SOPCAST-CHANNEL:PORT/???? TCP_PORT LOCAL-PORT
                        # > /dev/null &
                        # TCP_PORT: where the interchange of p2p have place
                        # LOCAL-PORT: where the video stream is generated
                        # Example: /usr/bin/sp-auth/sp-sc-auth sop://sop.rojadirecta.com:3912/6002 3908 8908
                        # mplayer -prefer-ipv4 -nolirc -ao alsa -vo gl2 -cache 8192 -framedrop http://localhost:8908
                        #self.sp_port += 1
                        #self.sp_tcp_port += 1
                        sp_command = cons.LIB_PATH + 'sp-sc-auth %s %s %s' %(url, self.sp_tcp_port, self.sp_port)
                        self.sp_thread = sopcastThread(sp_command)
                        self.sp_thread.start()
                        self.sp_thread.join(1.0)
                        # [FIXME] Maybe sopcast need a own cache config
                        cache = 100 # Test with 0.1 MB, Mplayer needs a good cache for this? (8 MB recommended?)
                        #[TODO] Make a GUI option for autosync that improve some audio channels but maybe can choopy the video for stalls for synchronize:  -autosync 30
                        command = '%s -prefer-ipv4 -slave -idle -nolirc -nomouseinput -vo %s -ao alsa -cache %i %s -framedrop -input file=%s http://localhost:%s/tv.asf' %('mplayer', cons.DEFAULT_VO, cache, self.xid, cons.FIFO, self.sp_port)  #u.user_agent() -user-agent \'%s\'
                        time.sleep(0.2) # Wait to sp-sc-auth
                        self.proc = Popen(command.split(), stdin=sp.PIPE, stdout=open(cons.STDOUT, 'w+b'), stderr=open(cons.STDOUT, 'w+b'))

                else:
                    # [TODO] Ipv4 o ipv6 should be customizable
                    # -framedrop for old ATI cards (like mine! ATI Mobility Radeon X600(r380))
                    # If on fullscreen is slow you can change -vo option to other option (complete list: $mplayer -vo help)
                    #  -autosync 30

                    if platform.system() == 'Windows':
                        #import win32pipe
                        if cons.DEBUG:
                            print 'Handle:', self.xid
                        command = self.mplayer_bin
                        command_aux = ' %s -slave -vo gl2 -nolirc -framedrop -playlist %s \B' % (self.xid, url) #u.user_agent() -user-agent \'%s\'
                        command = command + command_aux

                        #  -vo gl -playlist http://24h.rtve.stream.flumotion.com/rtve/24h.flv.m3u
                        self.proc = Popen(command, stdin=sp.PIPE, stdout=open(cons.STDOUT, 'w+b'), stderr=open(cons.STDOUT,"r+b"))
                    else:
                        command = '%s -prefer-ipv4 -slave -idle -nolirc -nomouseinput -vo %s -framedrop -ao alsa -cache %i %s %s -input file=%s' % (self.mplayer_bin, cons.DEFAULT_VO, cache, self.xid, url, cons.FIFO) #u.user_agent() -user-agent \'%s\'
                        # command = 'cvlc --drawable-xid %i %s' % (self.videoArea.window.xid, url) # [FIXME] This need a slave mode? Does vlc a slave mode?
                        self.proc = Popen(command.split(), stdin=sp.PIPE, stdout=open(cons.STDOUT, 'w+b'), stderr=open(cons.STDOUT,"r+b"))

                if cons.DEBUG and play_ok:
                    print 'DEFAULT_VO:', cons.DEFAULT_VO
                    print _('Note: You can change DEFAULT_VO with other options that can be found with the command "mplayer -vo help"')
                    if sp_command != None:
                        print sp_command
                    print command

                if play_ok:
                    if not self.progressbar.get_property('visible'):
                        self.progressbar.set_property('visible', True)
                        self.progressbar.show()
                    #self.proc = Popen(command.split(), stdin=sp.PIPE, stdout=sp.PIPE, stderr=sp.PIPE)

                    #self.proc = Popen(command.split(), stdin=subprocess.PIPE, stdout=open(cons.STDOUT,"w+b"))
                    #print self.proc.stdout.readline()
                    #print 'STDOUT',self.proc.stdout
                    #print 'STDOUT', self.proc.stdout

                    #for line in open(cons.STDOUT,"w+b"):
                    #    print line

                    #self.proc.stdin.flush()
                    #for line in readlines(open(cons.STDOUT,"w+b")):
                    #     print line,
                    #self.proc.wait()

                    self.isPlaying = True
                    self.isPaused  = False
                    self.isStop    = False
                    cons.lastProcess = self.proc

                    self.mplayerClient = open(cons.FIFO,"w")
                    #self.progressLog = open(cons.STDOUT,"r")
                    #self.progressLog = self.proc.stdin
                    #self.errLog = open(cons.STDOUT,"r")

                    self._execute('play', False)

                    # [TODO] Show osd msg
                    #msg = "hello"
                    #self._execute('osd_show_text "%s"\n' % msg, False)

                    self.progressbar.set_fraction(0.0)
                    self.progressbar.set_text(_('Loading...'))

                    self.pt_enter = False
                    self.sc = showCmd(self.proc, self.progressbar, self.progress_timeout, self)
                    self.sc.start()
                    self.sc.join(0.5)
                    self.sc.init_channel = False
                    # Add callback for progressbar

                    self.timer = gobject.timeout_add(100, self.progress_timeout, self)

                    """while True:
                        line = self.proc.stdout.readline()
                        print line,
                        if not line: break
                    """
                    self.push_status(_('Playing: %s') % name)
                    
    def selectChannel(self, widget, event, *args):
        # we should run again this method only if the user has moved
        # from the last channel [TODO]. Imagine the user holding enter pressed
        # BUT also allow click on channel
        if event.button == 3:
            path_tree = widget.get_path_at_pos(int(event.x), int(event.y))
            if path_tree is not None:
                path, col, cellx, celly = path_tree
                widget.grab_focus()
                widget.set_cursor(path, col, 0)
                menu_channel = gtk.Menu()

                # [TODO] Put a gtk.Label on the popup menu with "Actions:"
                menus_channel = [ # gtk.Label('Actions:'), # [TODO] GtkWarning: gtk_menu_shell_insert: assertion `GTK_IS_MENU_ITEM (child)' failed
                         u.ImageMenuItem(_('Remove'), gtk.STOCK_DELETE),
                         u.ImageMenuItem(_('Report as broken'), gtk.STOCK_STOP),
                         u.ImageMenuItem(_('Vote'), gtk.STOCK_ABOUT),
                         u.ImageMenuItem(_('Get info'), gtk.STOCK_INFO)]
                for item in menus_channel:
                    menu_channel.append(item)
                    if type(item) == u.ImageMenuItem:
                        item.show()
                    #   item.connect('activate', self.on_menu_item_activated)

                menu_channel.show()
                menu_channel.popup(None, None, None, event.button, event.time)

            return True
        elif event.button == 1 and event.type == gtk.gdk._2BUTTON_PRESS:
            treeselection = widget.get_selection()
            (model, iter) = treeselection.get_selected()
            if iter != None: # Avoid double click on expand tree
                id = model.get_value(iter, cons.COLUMN_ID)
                if id == 0:
                    path = model.get_path(iter)
                    if self.channels.row_expanded(path):
                        self.channels.collapse_row(path)
                    else:
                        self.channels.expand_row(path, True)
                elif id != 0:
                    (name, country, url, channel_type, format_type) = self.get_data_channel_from_model(iter, model)

                    self.execute_channel(id, country, name, url, format_type, channel_type)

    def progress_timeout(self, pbobj):
        self.pt_enter = True
        if self.sc.init_channel == False:
            self.progressbar.pulse()
            new_val = self.progressbar.get_fraction() + 0.05
            if new_val > 1.0:
                new_val = 0.0
            self.progressbar.set_fraction(new_val)
            self.progressbar.set_text(_('Loading...'))
            return True
        else:
            self.pt_enter = False
            return False

    def __Channels(self):
        self.channels = gtk.TreeView()
        self.channels.set_headers_clickable(True)
        self.channels.set_headers_visible(True)
        self.channels.set_rules_hint(True)
        self.channels.add_events(gtk.gdk.BUTTON_PRESS_MASK)
        self.channels.connect('button_press_event', self.selectChannel)
        #self.channels.connect('row_activated', self.selectChannel) [TODO]
        self.__create_model()
        self.channels.expand_all()

    def __create_model(self):
        self.__set_model()
        self.model.clear()
        self.__add_columns()

    def __set_model(self):
        import gobject
        self.model = gtk.TreeStore(
                    gobject.TYPE_INT,       # ID
                    gobject.TYPE_STRING,    # COUNTRY
                    gobject.TYPE_INT,       # TYPE
                    gobject.TYPE_STRING,    # NAME
                    gobject.TYPE_STRING,    # URL
                    gobject.TYPE_INT)    # FORMAT TYPE
        self.channels.set_model(self.model)

    def __add_columns(self):
        column = gtk.TreeViewColumn(_('Channels'))
        renderer = gtk.CellRendererText()
        column.pack_start(renderer, True)
        column.set_attributes(renderer, markup = cons.COLUMN_NAME)
        column.set_resizable(False)
        column.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
        column.set_expand(False)
        column.set_sort_column_id(cons.COLUMN_COUNTRY)
        self.channels.append_column(column)

    def insert_channels(self, channel_type = None):
        self.__insert_channels(channel_type)

    def insert_channels_by_text(self, channel_type = None, channel_text = None):
        self.__insert_channels(channel_type, channel_text)

    def __insert_channels(self, channel_type = None, channel_text = None):
        self.model.clear()
        countries = {}

        if cons.DEBUG:
            if channel_text != None:
                print _('Channel text: %s' %channel_text)

        filter_type = [0, 0, 0, 0, 0]
        enable_filter_type = False

        if channel_text != None:
            if ':' in channel_text:
                channel_text_type = channel_text.split(':')
                if cons.DEBUG:
                    print _('Channels filters:'), channel_text_type

                if channel_text_type:
                    for cs in channel_text_type:
                        if cs == 'radio':
                            filter_type[0] = 1
                            enable_filter_type = True
                        elif cs == 'tv':
                            filter_type[1] = 1
                            enable_filter_type = True
                        elif cs == 'sopcast':
                            filter_type[2] = 1
                            enable_filter_type = True
                        elif cs == 'id':
                            filter_type[3] = 1
                            enable_filter_type = True
                        elif self.countries_names.get(unicode(cs)) != None:
                            filter_type[4] = 1
                            enable_filter_type = True
                            country_filtered = cs
                        else:
                            channel_text = cs
                    if cons.DEBUG:
                        print _('Channel text filtered: %s' %channel_text)

        if cons.DEBUG:
            print filter_type

        for c in self.channels_set:
            if countries.get(unicode(c[1])) == None:
                iter = self.model.append(None, [0, '', -1, c[1], '', -1]) # Only put the country on name place (Channel 0 reserved)
                countries[unicode(c[1])] = iter
            else:
                iter = countries.get(unicode(c[1]))

            if channel_type == None or channel_type == 'All' or channel_type == c[2]:
                if len(c) == 5:
                    c.append(cons.UNKNOWN)

                # Search channels
                if channel_text == '':
                    channel_ok = False
                    if filter_type[0] == 1:
                        if c[2] == cons.RADIO:
                            channel_ok = True
                    if filter_type[1] == 1:
                        if c[2] == cons.TV:
                            channel_ok = True
                    if filter_type[2] == 1:
                        if c[2] == cons.SOPCAST:
                            channel_ok = True
                    if filter_type[4] == 1:
                        if c[1] == country_filtered:
                            channel_ok = True

                    if channel_ok:
                        self.insert_data(c[0], c[1], c[2], c[3], c[4], c[5], iter)

                elif channel_text != None:
                    if channel_text == 'restore' or channel_text == 'chuck': # Easter egg ;)
                        self.insert_data(c[0], c[1], c[2], c[3], c[4], c[5], iter)
                    elif channel_text == 'clean':
                        pass
                    elif filter_type[3] == 1:
                        v = int(channel_text)
                        if v > 0:
                            if int(c[0]) == v:
                                self.insert_data(c[0], c[1], c[2], c[3], c[4], c[5], iter)
                    else:
                        #Search related channels by radio, TV or sopcast or country
                        res = None
                        if channel_text:
                            p = re.compile(r'(' + channel_text + ')')
                            m = p.search(c[3])
                            res = None

                            if m:
                                res = m.group()
                                if cons.DEBUG:
                                    print _('Match found: %s' % res)
                                    print _('Item found: %s' % c[3])
                            else:
                                res = None

                        if res:
                            channel_ok = True
                            if enable_filter_type:
                                channel_ok = False

                                if filter_type[0] == 1:
                                    if c[2] == cons.RADIO:
                                        channel_ok = True
                                if filter_type[1] == 1:
                                    if c[2] == cons.TV:
                                        channel_ok = True
                                if filter_type[2] == 1:
                                    if c[2] == cons.SOPCAST:
                                        channel_ok = True
                                if filter_type[4] == 1:
                                    if c[1] == country_filtered:
                                        channel_ok = True

                            if channel_ok:
                                self.insert_data(c[0], c[1], c[2], c[3], c[4], c[5], iter)
                else:
                    self.insert_data(c[0], c[1], c[2], c[3], c[4], c[5], iter)

        # Remove empty country rows
        for row in self.model:
            if not self.model.iter_has_child(row.iter):
                self.model.remove(row.iter)

        # Expand all channels if the user make a search
        if channel_text != None:
            if channel_text == 'restore' or channel_text == 'chuck':
                self.channels.collapse_all()
            else:
                self.channels.expand_all()


    def insert_data(self, id, country, channel_type, name, url, format_type, iter):
        self.model.append(iter, [int(id), unicode(country), int(channel_type), unicode(name), unicode(url), int(format_type)])

    def __readXML(self, url):
        params = urllib.urlencode({'u': 'hdi_p', 'p': 'Uio43-Iud345-', 'a': 'hdi_api_get_channel_info', 'id': int(url)})
        f = urllib.urlopen("http://www.filmon.com/tv/?%s" % params)
        return f.read()

    def __parseXML(self, xmldata):
        """ Trying with XML """
        import xml.dom.minidom
        from xml.dom.minidom import Node

        doc = xml.dom.minidom.parseString(xmldata)
        try:
            url = doc.getElementsByTagName("url")[0].childNodes[0].data
            print url
        except IndexError:
            url = None

        if url != None:
            try:
                title = doc.getElementsByTagName("title")[0].childNodes[0].data
                print title
            except IndexError:
                title = None

        return (url, title)

    def __parseXMLRegex(self, xmldata, url):
        """ Trying with Regex """
        if url == None:
            p = re.compile(r'(<\!\[CDATA\[)(.*)(]]>)')
            m = p.search(xmldata)
            if m:
                url = m.group()[9:-3]
                if cons.DEBUG:
                    print _('Match found: %s' % url)
            else:
                url = None
                if cons.DEBUG:
                    print _('No match')
        return url

    def parseFilmon(self, url):
        xmldata = self.__readXML(url)

        if xmldata != None and xmldata != 'ERROR: channel not found!':
            if cons.DEBUG:
                print _('XMLDATA:')
                print xmldata

            (url, title) = self.__parseXML(xmldata)
            url = self.__parseXMLRegex(xmldata, url)
            if url == None:
                print _('Error: Channel Filmon parsing failed! Please report.')
        return url

    def __readA3URL(self):
        f = urllib.urlopen('http://antena3.stream.flumotion.com/antena3/antena3.asf.asx')
        data = f.read()
        if cons.DEBUG:
            print _('DATA:') + '\n' + data
        return data

    def __parseA3URL(self):
        data = self.__readA3URL()
        """
        The url http://195.10.10.10X:80/antena3/antena3.asf
        changes for avoid the server overload.
        Format:
        <ASX version = "3.0">
          <TITLE>Antena3</TITLE>
          <ENTRY>
            <TITLE>Antena3</TITLE>
            <REF HREF="http://83.231.187.101:80/antena3/antena3.asf" />
            <STARTTIME VALUE="00:00:00.001" />
          </ENTRY>
        </ASX>
        """
        p = re.compile(r'(<REF HREF=")(.*)(" \/>)')
        m = p.search(data)
        if m:
            url = m.group()[11:-4] # Cut the real value
            if cons.DEBUG:
                print _('Match found: %s' % url)
        else:
            url = None
            if cons.DEBUG:
                print _('No match')
        return url

if __name__ == '__main__':
    import logging
    logger = logging.getLogger('tivion')
    hdlr = logging.FileHandler('/tmp/tivion.log')
    formatter = logging.Formatter('%(asctime)s %(levelname)s %(message)s')
    hdlr.setFormatter(formatter)
    logger.addHandler(hdlr)
    logger.setLevel(logging.INFO)
    logger.info('Arguments:' + str(sys.argv))
    try:
        if len(sys.argv) > 1:
            
            for i in range(len(sys.argv)):
                if sys.argv[i] in ['-d','-debug']:
                    cons.DEBUG = True

                # [TODO] Improve this feature for get the name, format, channel type or other attributes
                if sys.argv[i] in ['-p','-play']:
                    if i+1 in range(len(sys.argv)):
                        if sys.argv[i+1] != None and sys.argv[i+1]:
                            if str(sys.argv[i+1]).isdigit():
                                cons.PLAY_CHANNEL_ID = str(int(sys.argv[i+1]))
                            else:
                                cons.PLAY_CHANNEL_URL = str(sys.argv[i+1])
                        else:
                            print _('Invalid argument for parameter -p. Try using a valid URL o Tivion Channel ID')
                    else:
                        print _('Invalid argument for parameter -p. Try using a valid URL o Tivion Channel ID')

                if sys.argv[i] in ['-c','-channel-list']:
                    from channels import CHANNEL_VERSION, CHANNEL
                    from time import strftime, gmtime
                    print _('Channel list (%s):') %strftime("%A, %d %B %Y %H:%M:%S", gmtime(int(CHANNEL_VERSION)))

                    # Thanks to the IRC channel #pyar for his magic!
                    import operator
                    d = {}
                    for channel in CHANNEL:
                        #id, country, type, name, url, format_type
                        country = channel[1]
                        channel_type = channel[2]
                        name = channel[3]
                        d.setdefault(country, []).append((name, channel_type))

                    ordered = sorted(d.items(), key = lambda x: len(x[1]), reverse = True)
                    p , nn = 0, 0
                    for country, nc in ordered:
                        p = p + 1
                        print _('Country %s - ' %p) + _('%s - Total: ' %country) + ('%d' %len(nc))
                        for c, channel_type in sorted(nc):
                            nn = nn + 1
                            if channel_type == 0:
                                channel_type = _('TV')
                            elif channel_type == 1:
                                channel_type = _('Radio')
                            elif channel_type == 2:
                                channel_type = _('Sopcast')
                            print '  %s - %s (%s)' % (nn, c, channel_type)
                        print

                    print 'Total countries: %s\nTotal channels: %s' %(p, nn)
                    sys.exit(0)

                if sys.argv[i] == '-vo':
                    if i+1 in range(len(sys.argv)):
                      # Audio Output: alsa, alsa5, oss, sdl, arts, esd, jack, nas, macosx,
                      # openal, pulse, sgi, sun, win32, dsound, dart, dxr2,
                      # ivtv, v4l2, mpegpes, null, pcm, plugin
                      # Video Output: xv, x11, xover, vdpau, xvmc, dga, sdl,
                      # vidix, xvidix, cvidix, winvidix, direct3d, directx,
                      # kva, quartz, macosx, fbdev, fbdev2, vesa, svga, gl,
                      # gl2, null, aa, caca, bl, ggi, directfb, dfbmga, mga,
                      # xmga, s3fb, wii, 3dfx, tdfxfb, tdfx_vid, dxr2, dxr3,
                      # ivtv, v4l2, mpegpes, zr, zr2, md5sum, yuv4mpeg,
                      # gif89a, jpeg, pnm, png, tga
                      if sys.argv[i+1] != None and sys.argv[i+1] in ['xv','x11','xover','gl','gl2','sdl', 'xmga', 'mgba']:
                        cons.DEFAULT_VO = sys.argv[i+1] # [FIXME] SDL display another window!
                      else:
                        cons.DEFAULT_VO = 'gl2'

                if sys.argv[i] in ['-h','-help']:
                    print cons.VERSION
                    print _('Help: todo')
                    sys.exit(0)

        if cons.DEBUG:
            print _('*** DEBUG ***')
            print _('You can see additional output logs of Mplayer in %s') % cons.STDOUT
            print _('Note: the output log is removed when the program is closed.')
            print 'GTK: %s.%s.%s' %(gtk_v[0], gtk_v[1], gtk_v[2])
            print 'PyGTK: %s.%s.%s' %(pygtk_v[0], pygtk_v[1], pygtk_v[2])
            print _('Username:'), os.environ.get('USERNAME')
            print _('User language:'), u.get_default_lang()
            print _('Current locale:'), cur_locale
            print _('Current domain:'), gettext._current_domain
            print _('Default locale dir:'), gettext._default_localedir
            if platform.system() == 'Windows':
                gettext_package = 'None (Windows)'
            else:
                gettext_package = gettext.__package__
            print _('Gettext package:'), gettext_package

        if u.check_player():
            app = Tivion()
            gtk.main()
        else:
            if platform.system() == 'Windows':
                print _("MPlayer must be installed and be found in %s"% (os.environ['PROGRAMFILES'] + '/' + cons.VERSION_NAME)) #and Serpentine, VLC: /usr/bin/vlc
            else:
                print _("MPlayer must be installed and be found in /usr/bin") #and Serpentine, VLC: /usr/bin/vlc
    except KeyboardInterrupt:
        if os.path.exists(cons.FIFO):
            os.unlink(cons.FIFO)

        if os.path.exists(cons.STDOUT):
            os.unlink(cons.STDOUT)

        if os.path.exists(cons.STDERR):
            os.unlink(cons.STDERR)

        if cons.lastProcess != None:
            u.pterminate(cons.lastProcess)

        try:
            if app:
                if hasattr(app, 'sc'):
                    app.sc.quit = True
                if hasattr(app, 'sp_thread'):
                    try:
                        app.sp_thread.quit = True
                    except IOError:
                        pass
                if hasattr(app, 'proc'):
                    try:
                       if not app.proc.stdin.closed:
                           app.proc.stdin.write('quit\n')
                           app.proc.stdin.flush()
                           app.proc.stdin.close()
                       u.pterminate(app.proc)
                    except IOError:
                        pass
        except NameError:
            pass

        print _("Program terminated by keyboard.")
        sys.exit(1)
