### Tivion NSI installer for Windows ###

# Main vars
!define exe "tivion.py"
!define link "Tivion.lnk"
!define install_path "$PROGRAMFILES\Tivion"
!define source_path "dist\windows\wbuild\"
!define install_file "tivion-0.0.4.exe" # set the name of the installer
;!define config_path ${}\Tivion
;!define config_file "config.ini"

# Product vars
!define PRODUCT_NAME "Tivion"
!define PRODUCT_VERSION "0.0.4.0"
!define PRODUCT_PUBLISHER "Tivion Project"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\${exe}"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

; Best Compression
SetCompress Auto
SetCompressor /SOLID lzma
SetCompressorDictSize 32
SetDatablockOptimize On

; !defines for use with SHChangeNotify
!ifdef SHCNE_ASSOCCHANGED
!undef SHCNE_ASSOCCHANGED
!endif
!define SHCNE_ASSOCCHANGED 0x08000000
!ifdef SHCNF_FLUSH
!undef SHCNF_FLUSH
!endif
!define SHCNF_FLUSH        0x1000
!define SHCNF_IDLIST 0

!include Sections.nsh

; MUI 1.67 compatible ------
!include "MUI2.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "src/data/img/tivion.ico"
!define MUI_UNICON "src/data/img/tivion_uninstall.ico"
;!define MUI_WELCOMEFINISHPAGE_BITMAP "src/data/img/tivion.ico" ; optional

; Interface Configuration
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_RIGHT
#!define MUI_HEADERIMAGE_BITMAP "src/data/img/tivion.ico" #"res\ge_top.bmp"
#!define MUI_HEADERIMAGE_UNBITMAP "uninstall.bmp"
#!define MUI_WELCOMEFINISHPAGE_BITMAP "src/data/img/tivion.ico" #"res\ge_left.bmp"
#!define MUI_UNWELCOMEFINISHPAGE_BITMAP "wizard.bmp"

;TODO: We need to make the dialogs use several languages

Function .onInit
    BringToFront
    ; Check if already running
    ; If so don't open another but bring to front
      System::Call "kernel32::CreateMutexA(i 0, i 0, t '$(^Name)') i .r0 ?e"
      Pop $0
      StrCmp $0 0 launch
       StrLen $0 "$(^Name)"
       IntOp $0 $0 + 1
      loop:
        FindWindow $1 '#32770' '' 0 $1
        IntCmp $1 0 +4
        System::Call "user32::GetWindowText(i r1, t .r2, i r0) i."
        StrCmp $2 "$(^Name)" 0 loop
        System::Call "user32::ShowWindow(i r1,i 9) i."         ; If minimized then maximize
        System::Call "user32::SetForegroundWindow(i r1) i."    ; Brint to front
        Abort
      launch:

  ;!insertmacro MUI_LANGDLL_DISPLAY ; This macro break all language! Danger!
  
; Check to see if already installed
  ReadRegStr $R0 HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}" "UninstallString"
  IfFileExists $R0 +1 NotInstalled
  #messagebox MB_DEFBUTTON4|MB_TOPMOST "It seems that ${PRODUCT_NAME} is already installed." 
        #"Uninstall" "Cancel"
        Pop $R1
  StrCmp $R1 2 Quit +1
  Exec $R0
Quit:
  Quit
NotInstalled:
FunctionEnd

Function un.onUninstSuccess
  #HideWindow
  #MessageBox MB_ICONINFORMATION|MB_OK "Tivion will not play anymore here :-(."
; Refresh the System
  System::Call 'Shell32::SHChangeNotify(i ${SHCNE_ASSOCCHANGED}, i ${SHCNF_IDLIST}, i 0, i 0)'
FunctionEnd

Function .onInstSuccess
; Refresh the System
  System::Call 'Shell32::SHChangeNotify(i ${SHCNE_ASSOCCHANGED}, i ${SHCNF_IDLIST}, i 0, i 0)'
FunctionEnd


#!macro DOWN_LANGUAGE DL_LANGUAGE
# 
#   !insertmacro MUI_LANGUAGE "${DL_LANGUAGE}"
#   !include "DL_${DL_LANGUAGE}.nsh"
#   !insertmacro BUILD_LANGSTRINGS
 
#!macroend

#!insertmacro DOWN_LANGUAGE "English"
#!insertmacro DOWN_LANGUAGE "Greek"




;Show all languages, despite user's codepage
!define MUI_LANGDLL_ALLLANGUAGES

;Language Selection Dialog Settings

  ;Remember the installer language
  !define MUI_LANGDLL_REGISTRY_ROOT "HKCU" 
  !define MUI_LANGDLL_REGISTRY_KEY "Software\Tivion" 
  !define MUI_LANGDLL_REGISTRY_VALUENAME "Installer Language"



Function LaunchLink
  ExecShell "" "$SMPROGRAMS\${PRODUCT_NAME}\${link}"
FunctionEnd



; Welcome page
#Function wel_show
#    FindWindow $1 "#32770" "" $HWNDPARENT
#    SetCtlColors $1 '' '0x000000'
#
#    GetDlgItem $2 $1 1201
#    SetCtlColors $2 '0x00FF00' '0x000000'

#    GetDlgItem $2 $1 1202
#    SetCtlColors $2 '0xFFFF00' '0x000000'
#    CreateFont $1 "$(^Font)" "10" ""
#    SendMessage $2 ${WM_SETFONT} $1 0
#FunctionEnd

#!define MUI_PAGE_CUSTOMFUNCTION_SHOW wel_show

!insertmacro MUI_PAGE_WELCOME

; Licence
!define MUI_LICENSEPAGE_CHECKBOX
!insertmacro MUI_PAGE_LICENSE COPYING
; Directory

# Custom page text
#!define MUI_PAGE_HEADER_TEXT "header here"
#!define MUI_PAGE_HEADER_SUBTEXT "subtext here"
#!define MUI_INSTFILESPAGE_FINISHHEADER_TEXT ""
#!define MUI_INSTFILESPAGE_FINISHHEADER_SUBTEXT ""

#!insertmacro MUI_PAGE_COMPONENTS


!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES ; Instfiles page
; Finish page
!define MUI_FINISHPAGE_NOAUTOCLOSE
!define MUI_FINISHPAGE_RUN 
!define MUI_FINISHPAGE_RUN_NOTCHECKED
;!define MUI_FINISHPAGE_RUN_TEXT "Start a shortcut"
!define MUI_FINISHPAGE_SHOWREADME_NOTCHECKED
!define MUI_FINISHPAGE_RUN_FUNCTION "LaunchLink"
!define MUI_FINISHPAGE_SHOWREADME $INSTDIR\readme.txt
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_WELCOME
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_COMPONENTS
!insertmacro MUI_UNPAGE_DIRECTORY
!insertmacro MUI_UNPAGE_INSTFILES
;!define MUI_FINISHUNPAGE_NOAUTOCLOSE
!insertmacro MUI_UNPAGE_FINISH

; Language files
  !insertmacro MUI_LANGUAGE "English" ;first language is the default language
  !insertmacro MUI_LANGUAGE "French"
  !insertmacro MUI_LANGUAGE "German"
  !insertmacro MUI_LANGUAGE "Spanish"
  !insertmacro MUI_LANGUAGE "SpanishInternational"
  !insertmacro MUI_LANGUAGE "SimpChinese"
  !insertmacro MUI_LANGUAGE "TradChinese"
  !insertmacro MUI_LANGUAGE "Japanese"
  !insertmacro MUI_LANGUAGE "Korean"
  !insertmacro MUI_LANGUAGE "Italian"
  !insertmacro MUI_LANGUAGE "Dutch"
  !insertmacro MUI_LANGUAGE "Danish"
  !insertmacro MUI_LANGUAGE "Swedish"
  !insertmacro MUI_LANGUAGE "Norwegian"
  !insertmacro MUI_LANGUAGE "NorwegianNynorsk"
  !insertmacro MUI_LANGUAGE "Finnish"
  !insertmacro MUI_LANGUAGE "Greek"
  !insertmacro MUI_LANGUAGE "Russian"
  !insertmacro MUI_LANGUAGE "Portuguese"
  !insertmacro MUI_LANGUAGE "PortugueseBR"
  !insertmacro MUI_LANGUAGE "Polish"
  !insertmacro MUI_LANGUAGE "Ukrainian"
  !insertmacro MUI_LANGUAGE "Czech"
  !insertmacro MUI_LANGUAGE "Slovak"
  !insertmacro MUI_LANGUAGE "Croatian"
  !insertmacro MUI_LANGUAGE "Bulgarian"
  !insertmacro MUI_LANGUAGE "Hungarian"
  !insertmacro MUI_LANGUAGE "Thai"
  !insertmacro MUI_LANGUAGE "Romanian"
  !insertmacro MUI_LANGUAGE "Latvian"
  !insertmacro MUI_LANGUAGE "Macedonian"
  !insertmacro MUI_LANGUAGE "Estonian"
  !insertmacro MUI_LANGUAGE "Turkish"
  !insertmacro MUI_LANGUAGE "Lithuanian"
  !insertmacro MUI_LANGUAGE "Slovenian"
  !insertmacro MUI_LANGUAGE "Serbian"
  !insertmacro MUI_LANGUAGE "SerbianLatin"
  !insertmacro MUI_LANGUAGE "Arabic"
  !insertmacro MUI_LANGUAGE "Farsi"
  !insertmacro MUI_LANGUAGE "Hebrew"
  !insertmacro MUI_LANGUAGE "Indonesian"
  !insertmacro MUI_LANGUAGE "Mongolian"
  !insertmacro MUI_LANGUAGE "Luxembourgish"
  !insertmacro MUI_LANGUAGE "Albanian"
  !insertmacro MUI_LANGUAGE "Breton"
  !insertmacro MUI_LANGUAGE "Belarusian"
  !insertmacro MUI_LANGUAGE "Icelandic"
  !insertmacro MUI_LANGUAGE "Malay"
  !insertmacro MUI_LANGUAGE "Bosnian"
  !insertmacro MUI_LANGUAGE "Kurdish"
  !insertmacro MUI_LANGUAGE "Irish"
  !insertmacro MUI_LANGUAGE "Uzbek"
  !insertmacro MUI_LANGUAGE "Galician"
  !insertmacro MUI_LANGUAGE "Afrikaans"
  !insertmacro MUI_LANGUAGE "Catalan"
  !insertmacro MUI_LANGUAGE "Esperanto"
  ;!insertmacro MUI_LANGUAGE "Asturian" Dont work?
  !insertmacro MUI_RESERVEFILE_LANGDLL  ; Improved load time

;LangString COMPLETA ${LANG_SPANISH} "Completa"
;LangString COMPLETA ${LANG_ENGLISH} "Full"
;LangString MINIMA ${LANG_SPANISH} "Optima"
;LangString MINIMA ${LANG_ENGLISH} "optimal"

;InstType $(COMPLETA)
;InstType $(MINIMA) 

; File info
VIProductVersion "${PRODUCT_VERSION}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "${PRODUCT_NAME} ${PRODUCT_VERSION}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "CompanyName" "${PRODUCT_PUBLISHER}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" "${PRODUCT_COPYRIGHT}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "${PRODUCT_NAME} Installer"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "${PRODUCT_VERSION}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "OriginalFilename" "${INSTALLER_NAME}"


# Installer config
Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "${install_file}"
InstallDir "${install_path}"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
BrandingText "${PRODUCT_NAME}"
ShowInstDetails show
ShowUnInstDetails show
CRCCheck on
XPStyle on
;RequestExecutionLevel admin
;MessageBox MB_OK $DOCUMENTS

;Request application privileges for Windows Vista
RequestExecutionLevel user

# Installer sections
#SectionGroup !Python SecGrp_Python
# Section "!Python 2.6" Sec_py26
#        SetOutPath $INSTDIR
#        SetOverwrite on
#        File installers\python-2.6.5.msi
#        ExecWait '$INSTDIR\python-2.6.5.msi /SILENT'
#        Delete $INSTDIR\python-2.6.5.msi
#        WriteRegStr HKLM "${REGKEY}\Components" "Python 2.6" 1
#    SectionEnd
#    LangString DESC_Sec_Python ${LANG_ENGLISH} "Python language.  Required for Tivion.  www.python.org"
#SectionGroupEnd


# create a default section.
section
    SetShellVarContext all
    SetOverwrite ifnewer
    SetOutPath "$INSTDIR"
    File /r "${source_path}"
    
    CreateDirectory "$SMPROGRAMS\${PRODUCT_NAME}"
    CreateShortCut "$SMPROGRAMS\${PRODUCT_NAME}\${link}" "python.exe" "tivion.py" "$INSTDIR\data\img\tivion.ico"
    CreateShortCut "$DESKTOP\${link}" "python.exe" "tivion.py" "$INSTDIR\data\img\tivion.ico" 0 SW_SHOWNORMAL CONTROL|ALT|T "A simple streaming player"
 
    # create a popup box, with an OK button and the text "Hello world!"
    #messageBox MB_OK "Hello world!"

 
sectionEnd

Section -AdditionalIcons
  CreateShortCut "$SMPROGRAMS\${PRODUCT_NAME}\Uninstall Tivion.lnk" "$INSTDIR\uninst.exe" "" "$INSTDIR\data\img\tivion_uninstall.ico" 0 SW_SHOWNORMAL CONTROL|ALT|U "Uninstall Tivion"
  CreateShortCut "$SMPROGRAMS\${PRODUCT_NAME}\Tivion.lnk" "python.exe" ' "$INSTDIR\tivion.py" ' "$INSTDIR\data\img\tivion.ico" 0 SW_SHOWNORMAL CONTROL|ALT|T "A simple streaming player"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\${exe}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\${exe}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
  ;Exec "$INSTDIR\configuration.exe"
SectionEnd

Function un.onInit
  #MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Do you want uninstall ${PRODUCT_NAME}? Are you sure?" IDYES +2
  #Abort
FunctionEnd

Section Uninstall
  SetShellVarContext all
  Exec "$INSTDIR\${exe} -remove"
  RMDir /r "$SMPROGRAMS\${PRODUCT_NAME}"
  RMDir /r $INSTDIR
  Delete "$DESKTOP\${link}"
  Delete "$SMPROGRAMS\${PRODUCT_NAME}\${link}" 
  Delete "$SMPROGRAMS\${PRODUCT_NAME}" 
  Delete "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd
